 ###############################################
#           Messages Delivery Service           #
#    v2.11 (07/12/2010)     2010 MenzAgitat    #
#                                               #
#   IRC: irc.epiknet.org  #boulets / #eggdrop   #
#          http://www.boulets-roxx.com          #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#        ou  http://www.egghelp.org             #
#                                               #
 ###############################################
#    Remerciements  Artix et  Galdinx pour    #
# certaines ides et  Merwin pour ses conseils #
#           d'optimisation du code.             #
 ###############################################

#
# REMARQUE IMPORTANTE : Ce script est susceptible de fonctionner ou non avec
#		les rglages par dfaut et suivant le serveur IRC sur lequel vous tes.
#		Il est conu pour fonctionner sur UnrealIRCd avec Epona, Anope ou drivs.
#		Veuillez vous reporter  la section configuration plus bas.
#

##############	Description
#
# Connaissez-vous MemoServ ? Il s'agit d'un service disponible sur certains
# serveurs IRC permettant d'envoyer un message  un utilisateur, qu'il soit
# connect ou non. Bonne ide en soi si certains dfauts majeurs ne le rendaient
# pas quasiment inutile :
#	-	Il ne vous permet pas d'envoyer de messages si vous n'avez pas enregistr
#		et identifi votre nick.
#	-	Il ne permet pas d'envoyer de messages  un utilisateur n'ayant pas
#		enregistr son nick.
#	-	Lorsque vous avez un message, MemoServ vous en informe au moment de votre
#		connexion au serveur et l'information est noye dans les nombreuses notices
#		que le serveur vous envoie  ce moment prcis. Qui lit scrupuleusement ce
#		flood lorsqu'il se connecte ? Pas moi. Par consquent, il m'est arriv de
#		m'apercevoir que j'avais un message sur MemoServ 8 mois aprs qu'il ait t
#		envoy; a se passe de commentaires.
#
# Et voici Messages Delivery Service, que j'appellerai MDS pour plus de
# simplicit.
# MDS permet d'envoyer un message  une personne (qui n'a pas besoin d'tre
# connecte) et de s'assurer que le message sera bien dlivr dans les meilleurs
# dlais.
# Ds que le destinataire rejoindra un des chans sur lesquels le bot se trouve
# ou qu'il y parlera, donc ds qu'on pourra tre certain qu'il y porte
# attention, un message lui sera affich afin de lui indiquer qu'il a des
# messages non-lus.
# Il pourra alors taper !lire (par dfaut) pour les recevoir.
# Si l'utilisateur ne lit pas ses messages, un rappel lui indiquant qu'il a des
# messages en attente s'affichera toutes les 30mn (rglable) s'il manifeste sa
# prsence en parlant. Ce compteur de 30mn est rinitialis si de nouveaux
# messages lui sont envoys entre temps.
#
# Lorsqu'un message est reu, un accus de rception est automatiquement envoy
#  l'expditeur pour l'en informer (optionnel). Il est galement possible pour
# le destinataire de confirmer avoir lu le message au moyen de la commande
# !lu <n d'identifiant du message> (optionnel). Si une confirmation de lecture
# est envoye, elle remplace l'accus de rception.
#
# Concernant la confidentialit, MDS s'assure du mieux qu'il peut qu'il ne
# dlivrera pas un message  la mauvaise personne.
# De plus, si l'identit de l'expditeur d'un message prsente une incohrence,
# le fait sera signal au destinataire ainsi qu'une estimation du niveau de
# confiance qu'il peut lui accorder en fonction du nombre et de la gravit des
# anomalies dtectes. Il sera alors libre de lui accorder ou non du crdit.
# Ce systme fonctionne conjointement avec les handles enregistrs sur l'eggdrop
# (et leurs listes de hosts associs), la vrification d'identit auprs de
# NickServ ou tout serveur de nick similaire (si disponible) et le recoupement
# de diverses informations disponibles afin de dtecter les anomalies.
# Avoir un nick enregistr ou un handle sur l'eggdrop augmente donc
# considrablement le niveau de scurit et permet de s'assurer que personne
# ne pourra lire vos messages  votre place. Pour ceux qui n'ont ni handle, ni
# nick enregistr, le bot ne pourra faire mieux que de dlivrer le message  la
# premire personne portant le mme nick.
# Veuillez noter que le bon fonctionnement de ce systme repose en partie sur
# une liste d'accs bien tenue, avec des masques de hosts pertinents et aussi
# prcis que possibles (je parle videmment de la liste d'accs de l'eggdrop).
# Si vous utilisez des handles gnriques, il est possible de les dclarer afin
# que le systme de scurit de MDS n'accorde pas trop de crdit  la
# reconnaissance par handle en ce qui les concerne.
# L'ide de base d'un handle gnrique est de regrouper plusieurs utilisateurs
# ayant un host identique (utilisateurs d'un mme bnc, d'un cybercaf, etc..)
# sous un mme handle dit "gnrique".
#
#	Si l'on tente d'envoyer un message trop long pour tre affich intgralement
# chez le destinataire, le bot nous en informe et affiche la limite  ne pas
# dpasser. Cette limite est dynamique et est calcule en fonction du nom du
# chan, du nick de l'expditeur, de la fioriture que vous avez choisie pour
# rendre bien visibles les messages recus, etc...
#
# L'activation/dsactivation du script sur chaque chan se fait au moyen de la
# commande de partyline .chanset #nomduchan [+/-]MDS
# Notez que ceci concerne uniquement l'utilisation des commandes de la
# messagerie, ce qui veut dire qu'une personne ayant un message et manifestant
# sa prsence sur un chan inactif sera quand mme avertie qu'elle a un message
# non-lu.
#
# Il est possible d'utiliser MDS pour envoyer des messages  des utilisateurs
# depuis d'autres scripts, une procdure existe dans ce but prcis.
# Cette procdure se trouve en dehors du namespace de MDS afin d'offrir une plus
# grande facilit d'utilisation; le revers potentiel est que si vous utilisez un
#	autre script qui dfinit une procdure du mme nom, il y aura un conflit.
#	Vous pourrez facilement corriger ce problme en modifiant le nom de ladite
# procdure dans MDS.
# Voici comment utiliser cette fonction :
# 	send_msg_to <destinataire>[,destinataire,...] <nom_du_script_appelant> <message>
# 		- Le nom du ou des destinataires peut tre un nick ou un handle.
#			- nom_du_script_appelant doit tre le nom du script qui envoie le message.
#				Le destinataire recevra le message sous la forme :
#				"Message de nom_du_script_appelant envoy le xx/xx/xxxx  xxhxx : blablabla".
# MDS dclare le package "MDS" afin que vous puissiez vrifier sa prsence
# depuis d'autres scripts au moyen de "package require MDS".
# Les messages envoys par ce biais ne sont pas soumis au contrle de longueur
# minimale et maximale du message ou du nombre maximum de destinataires, et
# l'anti-flood ne s'en occupe pas. Soyez donc responsable dans la faon dont
# vous l'utilisez.
#
# Pour les curieux, une annexe technique se trouve  la fin du script.
#
# Commandes par dfaut :
#		Envoyer un message depuis un chan :
#			!msg <destinataire>[,destinataire,...] <message>
#		Envoyer un message depuis un message priv :
#			/msg nom_du_bot msg <destinataire>[,destinataire,...] <message>
#		Recevoir ses messages non-lus depuis un chan :
#			!lire
#		Recevoir ses messages non-lus depuis une commande prive :
#			/msg nom_du_bot lire
#		Confirmer la lecture d'un message depuis un chan :
#			!lu <n d'identifiant du message>
#		Confirmer la lecture d'un message depuis un message priv :
#			/msg nom_du_bot lu <n d'identifiant du message>
#		Afficher la liste des destinataires ayant des messages en attente :
#			!messages
#

#
# Changelog
#
#	1.0		- 1re version publique
#	1.01	- Correction : demander l'affichage de la liste des destinataires
#					ayant d'un message ne provoque plus d'erreur si ladite liste est vide.
#				- Correction : crer manuellement le fichier base de donnes plutt
#					que le laisser tre cr automatiquement n'empche plus le script de
#					fonctionner.
#	1.02	- Correction : lorsque le bot dtectait une anomalie dans l'identit du
#					destinataire, une erreur se produisait parfois.
#				- Correction : terminer la liste de destinataires par une virgule (lors
#					d'un envoi multi-destinataires) ne pose plus de problme.
#				- Correction : dans certains cas, relever ses messages au moyen de la
#					commande "/msg nomdubot lire" provoquait une erreur.
#				- Correction : la version d'eggdrop est dsormais correctement dtecte.
#				- Correction : la confirmation d'envoi  plusieurs destinataires
#					s'affiche maintenant correctement.
#				- Ajout : une nouvelle option permet de rgler un dlai avant de
#					signaler  un utilisateur qu'il a de nouveaux messages lorsqu'il
#					rejoint un chan.
#	2.0		- Restructuration importante du script : scurit renforce contre les
#					fraudes, refonte du fonctionnement interne, modification du format
#					de la base de donnes (si vous possdez une base de donnes d'un
#					ancien format, elle sera automatiquement convertie).
#				- Correction : le cas o un destinataire a des messages  la fois sur
#					son nick et sur son handle (et que ces 2 derniers sont diffrents)
#					est maintenant gr.
#				- Modification : l'activation/dsactivation du script sur un chan se
#					fait maintenant au moyen d'un flag udef (.chanset #nomduchan [+/-]MDS)
#					Veuillez noter que le script est activ par dfaut sur tous les chans
#					lors de son 1er lancement.
#				- Ajout : si un utilisateur a dj pris connaissance d'un accus de
#					rception, il n'est plus possible d'envoyer une confirmation de
#					lecture en plus. Ceci vite de recevoir des doubles confirmations.
#				- Ajout : une nouvelle option permet d'imposer une longueur minimale
#					aux messages envoys.
#				- Ajout : protocole permettant  d'autres scripts d'utiliser MDS pour
#					envoyer des messages aux utilisateurs.
#				- Correction : bugs divers
# 2.1		- Correction : meilleur gestion des caractres spciaux dans les nicks
#				- Correction : bug lors de la vrification d'identit au cas o Nickserv
#					n'est pas disponible (merci  qr3nt)
#				- Modification : en raison des problmes rencontrs par les utilisateurs
#					n'ayant dfini aucun chan statique dans leur fichier eggdrop.conf, la
#					messagerie n'est dsormais plus active automatiquement sur tous les
#					chans lors du 1er lancement du script. Vous devrez donc l'activer
#					manuellement sur chaque chan au moyen de la commande :
#					.channel set #nomduchan +MDS ( taper en partyline)
#				- Ajout : nouvelle option permettant de fixer une limite au nombre de
#					messages qu'un mme utilisateur peut avoir en attente (option
#					max_messages_per_recipient). Les accuss de rception et les
#					confirmations de lecture ne comptent pas.
#				- Modification : il n'est maintenant plus possible d'envoyer un message
#					 l'eggdrop.
#				- Modification : si l'option permettant d'envoyer une confirmation de
#					lecture est dsactive (option AR_enabled), l'id du message n'est plus
#					affich au destinataire car cette information est inutile.
#				- Ajout : nouvelle option (admin_flags) permettant selon leurs flags,
#					d'exempter certains utilisateurs des restrictions suivantes lors de
#					l'envoi d'un message : contrle du nombre maximum de destinataires
#					(option max_recipients), contrle de flood lors de l'envoi de messages
#					(option cmdflood_msg) et contrle du nombre maximum de messages en
#					attente pour un destinataire donn (option max_messages_per_recipient)
#				- Ajout : nouvelle option permettant de dfinir un dlai aprs lequel un
#					message en attente expirera si son destinataire ne l'a pas lu (option
#					message_lifetime). La dure de vie d'un message est exprime en jours.
#					Lorsqu'un message expire, il est supprim de la base de donnes.
#					En raison de cet ajout, la structure de la base de donnes a chang.
#					Votre ancienne base de donnes de messages sera automatiquement
#					convertie vers le nouveau format aprs en avoir fait une copie de
#					sauvegarde. Si vous aviez encore une base de donnes au format v1.x,
#					elle sera de mme convertie au format v2.1.
#					La vrification des messages expirs a lieu une fois par jour juste
#					aprs le backup de la base de donnes.
# 2.1		- Correction : la vrification des messages expirs provoquait une
#					erreur.
#

#
# LICENCE:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#

if {[info commands MDS::uninstall] eq "::MDS::uninstall"} { MDS::uninstall }
# Note pour les programmeurs :
# Dans la version 1.6.19 d'eggdrop, le numro de version affich par .vbottree
# et [numversion] est incorrect; il affiche 1061800 ou 1061801, ce qui
# correspond  la version 1.6.18. On utilise donc une autre technique pour
# vrifier le numro de version.
if { [join [split [string range [lindex $version 0] 0 5] "."] ""] < 1619 } { putloglev o * "\00304\002\[Messages Delivery Service - ERREUR\]\002\003 La version de votre eggdrop est \00304\002$version\002\003; \002Messages Delivery Service\002 ne fonctionnera correctement que sur les eggdrops version 1.6.19 ou suprieure." ; return }
if { [info tclversion] < 8.5 } { putloglev o * "\00304\002\[Messages Delivery Service - ERREUR\]\002\003 \002Messages Delivery Service\002 ncessite que Tcl 8.5 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.5
namespace eval MDS {


############################
#      CONFIGURATION       #
############################

	# autorisations ncessaires pour pouvoir recevoir un message
	variable receivemsg_auth "-|-"
	# commande publique pour demander  lire ses messages
	variable pub_checkmsg_cmd "!lire"
	# commande prive pour demander  lire ses messages
	# par dfaut : /msg NomDuBot messages
	variable priv_checkmsg_cmd "lire"
	# commande et autorisations pour envoyer un message  quelqu'un depuis un chan
	variable pub_msg_cmd "!msg"
	variable pub_msg_auth "-|-"
	# commande et autorisations pour envoyer un message  quelqu'un depuis un message priv au bot
	variable priv_msg_cmd "msg"
	variable priv_msg_auth "-|-"
	# commande et autorisations pour afficher la liste des destinataires des messages en attente
	variable destlist_cmd "!messages"
	variable destlist_auth "m|m"
	# commande et autorisations pour envoyer une confirmation de lecture  l'expditeur d'un message
	variable pub_read_acknowledgement_cmd "!lu"
	variable pub_read_acknowledgement_auth "-|-"
	# commande et autorisations pour envoyer une confirmation de lecture depuis un message priv au bot
	variable priv_read_acknowledgement_cmd "lu"
	variable priv_read_acknowledgement_auth "-|-"

	# Nom du service de nick sur votre serveur (normalement NickServ mais certains
	# serveurs peuvent avoir personnalis le nom, comme sur Epiknet o il se nomme
	# Themis. Pour les serveurs IRC qui ne disposent pas de NickServ ou similaire,
	# mettez :   variable nickserv ""
	variable nickserv "NickServ"

	# lag maximum qu'on autorise pour la rponse des services lors d'une demande de STATUS (en secondes).
	variable serviceslag 10

	# Si votre bot possde des handles gnriques dans sa userlist, c'est  dire
	# des handles qui correspondent  plusieurs personnes  la fois, vous pourriez
	# vouloir les exclure afin de ne pas risquer de dlivrer par accident un
	# message au mauvais destinataire. Les handles exclus ne peuvent pas servir de
	# critre de reconnaissance pour dlivrer un message, les utilisateurs
	# concerns ne pourront donc tre reconnus que par leur nick.
	# Mettez les handle  exclure entre les {} et en les sparant par un espace.
	variable handle_exempt_list {}

	# Mode de dlivrance des messages (1 = notice ; 2 = priv)
	variable delivery_mode 1

	# Activer l'envoi automatique d'un accus de rception  l'expditeur d'un
	# message lorsque celui-ci a t dlivr ? (0 = non ; 1 = oui)
	variable AD_enabled 1

	# Activer la possibilit d'envoyer une confirmation de lecture  l'expditeur
	# lorsque l'on reoit un message ? (0 = non ; 1 = oui)
	# Remarque : une confirmation de lecture remplacera l'accus de rception
	# s'il a t envoy.
	variable AR_enabled 0

	# Activer la fonction multi-destinataires ?
	# Si cette fonction est active, il est possible d'envoyer un message 
	# plusieurs destinataires en mme temps. (0 = dsactiv ; 1 = activ)
	variable multi_recipient 1

	# A combien de destinataires maximum limite-t-on l'envoi de messages ?
	# (ncessite que la fonction multi-destinataires soit active)
	variable max_recipients 5

	# Longueur minimale que doit avoir un message pour tre accept
	variable min_message_length 10

	# Nombre maximal de messages qu'un mme utilisateur peut avoir en attente
	variable max_messages_per_recipient 10

	# Flags exempts du contrle du nombre maximum de destinataires (option
	# max_recipients), du contrle de flood lors de l'envoi de messages (option
	# cmdflood_msg) et du contrle du nombre maximum de messages en attente pour
	# un destinataire donn (option max_messages_per_recipient).
	# Cela permet par exemple  un administrateur d'ignorer ces restrictions.
	variable admin_flags "m|m"

	# Dure pendant laquelle un utilisateur peut envoyer une confirmation de
	# lecture aprs rception d'un message (en secondes)
	variable acknowledge_time 120

	# Lorsqu'un utilisateur rejoint un chan, combien de secondes attend-t-on avant
	# de lui signaler qu'il a des messages non-lus ?
	# Remarque : il est conseill de ne pas mettre un dlai trop court afin
	# d'viter que le message ne soit noy parmi les annonces du serveur,
	# les greets, etc...
	variable on_join_delay 20

	# Intervalle de temps minimum en minutes entre l'affichage de 2 messages
	# avertissant un utilisateur (en pv ou notice) qu'il a un message non-lu
	variable unread_msg_spacing 30

	# longueur maximale d'une ligne affichable (Si la fin de certaines lignes est
	# tronque, a signifie que vous devez diminuer cette valeur).
	variable max_line_length 440

	# Dure (en jours) aprs laquelle un message, qui n'a pas t lu par son
	# destinataire, expirera et sera supprim. Un message sera alors envoy
	#  l'expditeur pour l'informer que son message n'a pas t dlivr.
	variable message_lifetime 365

	# Heure du backup quotidien de la base de donnes. (00:00 = minuit)
	variable backuptime 00:01

	# Nom et chemin de la base de donnes des messages
	# Remarque : si vous spcifiez un rpertoire inexistant, vous devez le crer
	# manuellement. Le fichier, par contre, est cr automatiquement.
	variable msgdb_file "scripts/MDS_messages.db"

	# Activer les couleurs/gras/soulignement dans les messages du bot sur les chans ?
	# Remarque : n'influe pas sur l'apparence des messages envoys en notice ou priv
	variable codes 1

	# COULEURS
	# Les couleurs peuvent valoir entre 0 et 15, ou "" si vous n'en voulez pas.
	# La couleur de fond doit obligatoirement valoir "" si au moins une des autres
	# couleurs vaut "".
	#
	# Couleur par dfaut du texte
	variable num_def_color 00
	# Couleur secondaire du texte (pour les informations annexes
	variable num_sec_color 14
	# Couleur utilise pour les informations cl (id du message, type de message)
	variable num_key_color 14
	# Couleur utilise pour les avertissements critiques
	variable num_warn_color 04
	# Couleur utilise pour mettre quelque chose en vidence	
	variable num_flash_color 07
	# Couleur de fond du texte
	variable num_bg_color 01

	# Repre color s'affichant en dbut de ligne pour signaler un message.
	variable color_marker "\037\0035,6|\0036,12|\00312,3|\0033,9|\0039,8|\0038,7|\0037,4|\0034,5|\003\037"
	# Fioriture gauche de la liste de destinataires
	variable left_destlist_gimmick "\00314,01:\00315,01:\00300,01:\002:\002|\003"
	# Fioriture droite de la liste de destinataires
	variable right_destlist_gimmick "\00300,01|\002:\002:\00315,01:\00314,01:\003"

	#### PARAMETRES DE L'ANTI-FLOOD
	# Anti-flood (0 = dsactiv, 1 = activ)
	variable antiflood 1
	# Combien d'envois de messages sont autoriss en combien de temps ?
	# exemple : "6:30" = 6 commandes maximum en 30 secondes;
	# les suivantes seront ignores.
	variable cmdflood_msg "3:60"
	# Combien de demandes d'affichage de la liste des destinataires sont
	# autorises en combien de temps ?
	variable cmdflood_destlist "3:30"
	# Combien d'utilisations de la commande utilise pour lire les messages
	# sont autorises en combien de temps ?
	variable cmdflood_read "6:180"
	# Intervalle de temps minimum en secondes entre l'affichage de 2 messages
	# avertissant que l'anti-flood a t dclench (ne rglez pas cette valeur
	# trop bas afin de ne pas tre flood par les messages d'avertissement de
	# l'anti-flood...)
	variable antiflood_msg_interval 30



####################################################################
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
####################################################################

	###
	### Initialisation
	###
	variable scriptname "Messages Delivery Service"
  variable version "2.11.20101207"
	package provide MDS
	variable DEBUGMODE 0
  variable backuptime [split $backuptime ":"]
	variable floodsettingsstring [list "msg" $cmdflood_msg "destlist" $cmdflood_destlist "read" $cmdflood_read]
	variable floodsettings ; array set floodsettings $floodsettingsstring
	variable instance ; array set instance {}
	variable antiflood_msg ; array set antiflood_msg {}
	if { $delivery_mode == 1 } { variable delivery_mode "NOTICE" } { variable delivery_mode "PRIVMSG" }
	if { !$multi_recipient } { variable max_recipients 1 }
	if { ($num_def_color eq "") || ($num_sec_color eq "") || ($num_key_color eq "") || ($num_warn_color eq "") || ($num_flash_color eq "") } { variable num_bg_color "" }
	variable def_color "\003$num_def_color[if {[string is digit $num_bg_color]} { set dummy ",$num_bg_color" } { set dummy "" }]"
	variable sec_color "\003$num_sec_color[if {[string is digit $num_bg_color]} { set dummy ",$num_bg_color" } { set dummy "" }]"
	variable key_color "\003$num_key_color[if {[string is digit $num_bg_color]} { set dummy ",$num_bg_color" } { set dummy "" }]"
	variable warn_color "\003$num_warn_color[if {[string is digit $num_bg_color]} { set dummy ",$num_bg_color" } { set dummy "" }]"
	variable flash_color "\003$num_flash_color[if {[string is digit $num_bg_color]} { set dummy ",$num_bg_color" } { set dummy "" }]"
	setudef flag MDS
	# Procdure de dsinstallation
	# (le script se dsinstalle totalement avant chaque rehash ou  chaque relecture au moyen de la commande "source" ou autre)
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$MDS::scriptname...\002"
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " \{?(::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		foreach running_timer [timers] {
			if { [string match "*[namespace current]::*" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
		}
		foreach running_utimer [utimers] {
			if { [string match "*[namespace current]::*" [lindex $running_utimer 1]] } { killutimer [lindex $running_utimer 2] }
		}
		namespace delete ::MDS
	}
	# Lecture de la base de donnes des messages (si elle existe) et construction d'une liste des destinataires en attente
	variable recipientlist ""
	# remarque : si la db fait moins de 12 octets, elle est forcment invalide alors on la recre
	if { ([file exists $msgdb_file]) && ([file size $msgdb_file] >= 12)  } {
		set db_is_v1 0 ; set db_is_v2_0 0
		set fileId_msgdb [open $msgdb_file r]
		foreach msglineread [split [read $fileId_msgdb] "\n"] {
			if {$msglineread ne ""} {
				# si la ligne lue ne fait pas exactement 11 caractres de long, c'est un message
				if { [string length $msglineread] != 11 } {
					set split_msglineread [split $msglineread]
					# on vrifie le format du message dans la base de donnes; s'il est au format v1.x ou v2.0, on le note afin de convertir la db au format v2.1
					if { [string index [set msg_type_and_id [join [lindex $split_msglineread 0]]] 1] eq "(" } { set db_is_v1 1 }
					if { ([set timestamp [lindex $split_msglineread 7]] ne "") && (![::tcl::string::is digit [lindex $split_msglineread 7]]) } { set db_is_v2_0 1 }
					# on construit la liste des destinataires
					set recipient [lindex $split_msglineread 3]
					if {[set recipientlist_index [lsearch -exact -nocase -index 0 $recipientlist $recipient]] == -1} {
						if { [set msg_type [string index $msg_type_and_id 0]] eq "M" } {
							lappend recipientlist [list $recipient 1 0 0]
						} elseif { $msg_type eq "C" } {
							lappend recipientlist [list $recipient 0 1 0]
						} elseif { $msg_type eq "A" } {
							lappend recipientlist [list $recipient 0 0 1]
						}
					} else {
						if { [set msg_type [string index [join [lindex $split_msglineread 0]] 0]] eq "M" } {
							set recipientlist [lreplace $recipientlist $recipientlist_index $recipientlist_index [list $recipient [expr [lindex [set recipientlist_element [lindex $recipientlist $recipientlist_index]] 1] + 1] [lindex $recipientlist_element 2] [lindex $recipientlist_element 3]]]
						} elseif { $msg_type eq "C" } {
							set recipientlist [lreplace $recipientlist $recipientlist_index $recipientlist_index [list $recipient [lindex [set recipientlist_element [lindex $recipientlist $recipientlist_index]] 1] [expr [lindex $recipientlist_element 2] + 1] [lindex $recipientlist_element 3]]]
						} elseif { $msg_type eq "A" } {
							set recipientlist [lreplace $recipientlist $recipientlist_index $recipientlist_index [list $recipient [lindex [set recipientlist_element [lindex $recipientlist $recipientlist_index]] 1] [lindex $recipientlist_element 2] [expr [lindex $recipientlist_element 3] + 1]]]
						}
					}
				# si la ligne lue fait exactement 11 caractres de long, il s'agit du compteur de messages
				} else {
					variable current_msg_id [string range $msglineread 1 9]
				}
			}
		}
		close $fileId_msgdb
		# Si la base de donnes est au format v1.x, on la convertit au format v2.1
		if { $db_is_v1 } {
			putloglev o * "\00304\[$MDS::scriptname - INFO\]\003 Base de donnes au format v1.x dtecte -> Conversion au format v2.1..."
			set fileId_msgdb [open $msgdb_file r]
			foreach msglineread [split [read $fileId_msgdb] "\n"] {
				if {$msglineread ne ""} {
					regexp {^(.*)\((.*)\)} [lindex $msglineread 0] result msg_type msg_id
					if { [info exists result] } {
						lappend msg_db "$msg_type*$msg_id [join [lrange [split $msglineread] 1 6]] [clock scan [join [lrange [split $msglineread] 5 6]] -format "%d/%m/%Y %Hh%M"] [join [lrange [split $msglineread] 7 8]] - [join [lrange [split $msglineread] 9 end]]"
					} else {
						lappend msg_db $msglineread
					}
				}
			}
			close $fileId_msgdb
			set fileId_msgdb [open $MDS::msgdb_file w]
			foreach db_line $msg_db {
				puts $fileId_msgdb $db_line
			}
			close $fileId_msgdb
		# Si la base de donnes est au format v2.0, on la convertit au format v2.1
		} elseif { $db_is_v2_0 } {
			putloglev o * "\00304\[$MDS::scriptname - INFO\]\003 Base de donnes au format v2.0 dtecte -> Conversion au format v2.1..."
			set fileId_msgdb [open $msgdb_file r]
			foreach msglineread [split [read $fileId_msgdb] "\n"] {
				if {$msglineread ne ""} {
					if { [string length $msglineread] != 11 } {
						lappend msg_db "[join [lrange [split $msglineread] 0 6]] [clock scan [join [lrange [split $msglineread] 5 6]] -format "%d/%m/%Y %Hh%M"] [join [lrange [split $msglineread] 7 end]]"
					} else {
						lappend msg_db $msglineread
					}
				}
			}
			close $fileId_msgdb
			set fileId_msgdb [open $MDS::msgdb_file w]
			foreach db_line $msg_db {
				puts $fileId_msgdb $db_line
			}
			close $fileId_msgdb
		}
	# Cration d'une nouvelle base de donnes si elle n'existe pas ou si elle est invalide
	} else {
		file delete -force $MDS::msgdb_file
		variable current_msg_id 000000000
		set fileId_msgdb [open $MDS::msgdb_file a]
		puts $fileId_msgdb "\[000000000\]"
		close $fileId_msgdb
	}
}

###
### Protocole de communication avec d'autres scripts pour l'envoi de messages.
### Cette procdure permet  d'autres scripts d'envoyer des messages  un
### utilisateur via MDS.
### Syntaxe : send_msg_to <destinataire>[,destinataire,...] <nom_du_script_appelant> <message>
### Remarques :	- le nom du destinataire peut tre un nick ou un handle.
###							- nom_du_script_appelant doit tre le nom du script qui envoie
###								le message. Le destinataire recevra le message sous la forme :
###								"Message de nom_du_script_appelant envoy le xx/xx/xxxx  xxhxx : blablabla"
###
proc send_msg_to {recipient external_script_name message} {
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 send_msg_to : $recipient \00307|\003 $external_script_name \00307|\003 $message" }
	putloglev o * "\00314Message envoy par le script\003\002 $external_script_name\002\00314 depuis la proc\003\002 [lindex [split [info level [expr [info level] -1]]] 0]\002\00314 pour\003\002 $recipient\00314\002 :\003 $message"
	MDS::sendmsg $::botnick - [nick2hand $::botnick] $::botnick priv 0001000010 system $external_script_name "$recipient $message"
	return
}

###
### On vrifie si la personne qui a parl ou rejoint le chan a des messages en
### attente. Si c'est le cas, on lui signale qu'elle devra taper !messages pour
### les lire
###
proc MDS::check_if_message_on_join {nick host hand chan} {
	utimer $MDS::on_join_delay [list ::MDS::check_if_message $nick $host $hand $chan ""]
	return
}
proc MDS::action_check_if_message {nick host hand chan type arg} {
	if { ![::tcl::string::first "#" $chan] } {
		MDS::check_if_message $nick $host $hand $chan $arg
	}
	return
}
proc MDS::check_if_message {nick host hand chan arg} {
	set on_allowed_chan [channel get $chan MDS]
	if { ($arg ne $MDS::pub_checkmsg_cmd) && ($arg ne $MDS::pub_msg_cmd) && ($arg ne $MDS::pub_read_acknowledgement_cmd) } {
		if { $hand ne "*" } {
			set lower_hand [::tcl::string::tolower $hand]
			set lower_nick [::tcl::string::tolower $nick]
			if { [lsearch -exact -nocase $MDS::handle_exempt_list $hand] == -1 } {
				if { [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $hand]] != -1 } {
					# $nick a un handle qui n'est pas un handle gnrique ET $hand a un message
					lassign [lindex $MDS::recipientlist $recipientlist_index] dummy num_M num_C num_A
					set num_msg [expr $num_M + $num_C + $num_A]
					if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 \002$hand\002 a un message et a t reconnu par son handle. ---> on lui signale qu'il a $num_msg message[MDS::plural1 $num_msg]" }
					if { ($MDS::AR_enabled || $MDS::AD_enabled) && (($num_C > 0) || ($num_A > 0)) } {
						set details "$MDS::sec_color ([if { $num_M > 0 } { set dummy "\002$num_M\002 message[MDS::plural1 $num_M]" }][if { $MDS::AR_enabled && ($num_C != 0) } { if { $num_M > 0 } { set dummy ", " } { set dummy "" } ; set dummy "$dummy\002$num_C\002 confirmation[MDS::plural1 $num_C] de lecture" } { set dummy "" }][if { $MDS::AD_enabled && ($num_A != 0) } { if { ($num_M > 0) || ($num_C > 0) } { set dummy ", " } { set dummy "" } ; set dummy "$dummy\002$num_A\002 accus[MDS::plural1 $num_A] de rception" } { set dummy "" }])$MDS::def_color"
					} else { set details "" }
					MDS::inform_user_of_unread_msg $nick $host $hand "$MDS::color_marker $MDS::def_color Vous avez \002$num_msg\002 message[MDS::plural1 $num_msg] non lu[MDS::plural1 $num_msg]$details. Vous pouvez taper [if { $on_allowed_chan } { set dummy "\002$MDS::pub_checkmsg_cmd\002 ou " } { set dummy "" }]\002/msg $::botnick $MDS::priv_checkmsg_cmd\002 pour le[MDS::plural1 $num_msg] lire.\003"
					return
				} elseif { [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick]] != -1 } {
					# $nick a un handle qui n'est pas un handle gnrique ET $nick a un message
					lassign [lindex $MDS::recipientlist $recipientlist_index] dummy num_M num_C num_A
					set num_msg [expr $num_M + $num_C + $num_A]
					if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 \002$nick\002 a un message et a t reconnu par son pseudo. ---> on lui signale qu'il a $num_msg message[MDS::plural1 $num_msg]" }
					if { ($MDS::AR_enabled || $MDS::AD_enabled) && (($num_C > 0) || ($num_A > 0)) } {
						set details "$MDS::sec_color ([if { $num_M > 0 } { set dummy "\002$num_M\002 message[MDS::plural1 $num_M]" }][if { $MDS::AR_enabled && ($num_C != 0) } { if { $num_M > 0 } { set dummy ", " } { set dummy "" } ; set dummy "$dummy\002$num_C\002 confirmation[MDS::plural1 $num_C] de lecture" } { set dummy "" }][if { $MDS::AD_enabled && ($num_A != 0) } { if { ($num_M > 0) || ($num_C > 0) } { set dummy ", " } { set dummy "" } ; set dummy "$dummy\002$num_A\002 accus[MDS::plural1 $num_A] de rception" } { set dummy "" }])$MDS::def_color"
					} else { set details "" }
					MDS::inform_user_of_unread_msg $nick $host $hand "$MDS::color_marker $MDS::def_color Vous avez \002$num_msg\002 message[MDS::plural1 $num_msg] non lu[MDS::plural1 $num_msg]$details. Vous pouvez taper [if { $on_allowed_chan } { set dummy "\002$MDS::pub_checkmsg_cmd\002 ou " } { set dummy "" }]\002/msg $::botnick $MDS::priv_checkmsg_cmd\002 pour le[MDS::plural1 $num_msg] lire.\003"
					return
				} else { return }
			} else {
				if { [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick]] != -1 } {
					# $nick a un handle gnrique ET $nick a un message
					lassign [lindex $MDS::recipientlist $recipientlist_index] dummy num_M num_C num_A
					set num_msg [expr $num_M + $num_C + $num_A]
					if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 \002$nick\002 a un message et a t reconnu par son nick. ---> on lui signale qu'il a $num_msg message[MDS::plural1 $num_msg]" }
					if { ($MDS::AR_enabled || $MDS::AD_enabled) && (($num_C > 0) || ($num_A > 0)) } {
						set details "$MDS::sec_color ([if { $num_M > 0 } { set dummy "\002$num_M\002 message[MDS::plural1 $num_M]" }][if { $MDS::AR_enabled && ($num_C != 0) } { if { $num_M > 0 } { set dummy ", " } { set dummy "" } ; set dummy "$dummy\002$num_C\002 confirmation[MDS::plural1 $num_C] de lecture" } { set dummy "" }][if { $MDS::AD_enabled && ($num_A != 0) } { if { ($num_M > 0) || ($num_C > 0) } { set dummy ", " } { set dummy "" } ; set dummy "$dummy\002$num_A\002 accus[MDS::plural1 $num_A] de rception" } { set dummy "" }])$MDS::def_color"
					} else { set details "" }
					MDS::inform_user_of_unread_msg $nick $host $hand "$MDS::color_marker $MDS::def_color Vous avez \002$num_msg\002 message[MDS::plural1 $num_msg] non lu[MDS::plural1 $num_msg]$details. Vous pouvez taper [if { $on_allowed_chan } { set dummy "\002$MDS::pub_checkmsg_cmd\002 ou " } { set dummy "" }]\002/msg $::botnick $MDS::priv_checkmsg_cmd\002 pour le[MDS::plural1 $num_msg] lire.\003"
					return
				} else { return }	
			}
		} else {
			if { [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick]] != -1 } {
				# $nick n'a pas de handle ET $nick a un message
				lassign [lindex $MDS::recipientlist $recipientlist_index] dummy num_M num_C num_A
				set num_msg [expr $num_M + $num_C + $num_A]
				if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 \002$nick\002 a un message et a t reconnu par son nick. ---> on lui signale qu'il a $num_msg message[MDS::plural1 $num_msg]" }
					if { ($MDS::AR_enabled || $MDS::AD_enabled) && (($num_C > 0) || ($num_A > 0)) } {
						set details "$MDS::sec_color ([if { $num_M > 0 } { set dummy "\002$num_M\002 message[MDS::plural1 $num_M]" }][if { $MDS::AR_enabled && ($num_C != 0) } { if { $num_M > 0 } { set dummy ", " } { set dummy "" } ; set dummy "$dummy\002$num_C\002 confirmation[MDS::plural1 $num_C] de lecture" } { set dummy "" }][if { $MDS::AD_enabled && ($num_A != 0) } { if { ($num_M > 0) || ($num_C > 0) } { set dummy ", " } { set dummy "" } ; set dummy "$dummy\002$num_A\002 accus[MDS::plural1 $num_A] de rception" } { set dummy "" }])$MDS::def_color"
					} else { set details "" }
				MDS::inform_user_of_unread_msg $nick $host $hand "$MDS::color_marker $MDS::def_color Vous avez \002$num_msg\002 message[MDS::plural1 $num_msg] non lu[MDS::plural1 $num_msg]$details. Vous pouvez taper [if { $on_allowed_chan } { set dummy "\002$MDS::pub_checkmsg_cmd\002 ou " } { set dummy "" }]\002/msg $::botnick $MDS::priv_checkmsg_cmd\002 pour le[MDS::plural1 $num_msg] lire.\003"
				return
			} else { return }
		}
	}
}

###
### informe un utilisateur qu'il a des messages non lus
###
proc MDS::inform_user_of_unread_msg {nick host hand arg} {
	# on vrifie qu'on ne vient pas dj d'envoyer le message il y a peu de temps
	if { ![info exists MDS::unreadmsgtimertable([set clean_nick [MDS::clean_data $nick]])] } {
		variable unreadmsgtimertable
		set unreadmsgtimertable($clean_nick) 1
		timer $MDS::unread_msg_spacing [list unset ::MDS::unreadmsgtimertable($clean_nick)]
		puthelp "$MDS::delivery_mode $nick :$arg"
	}
	return
}

###
### Rinitialisation du statut de temporisation des rappels de messages non-lus
###
proc MDS::reset_unread_msg_status_on_quit {nick host hand chan arg} {
	MDS::reset_unread_msg_status $nick
	return
}
proc MDS::reset_unread_msg_status_on_kick {nick host hand chan target arg} {
	MDS::reset_unread_msg_status $nick
	return
}
proc MDS::reset_unread_msg_status_on_nick {nick host hand chan newnick} {
	MDS::reset_unread_msg_status $nick
	return
}
proc MDS::reset_unread_msg_status_on_splt {nick host hand chan} {
	MDS::reset_unread_msg_status $nick
	return
}
proc MDS::reset_unread_msg_status {nick} {
	if { [set unreadmsgtimer [lsearch -inline -index 1 [timers] "*MDS::unreadmsgtimertable([set clean_nick [MDS::clean_data $nick]])*"]] ne "" } {
		killtimer [lindex $unreadmsgtimer 2]
		if { [info exists MDS::unreadmsgtimertable($clean_nick)] } { unset MDS::unreadmsgtimertable($clean_nick) }
	}
}

###
### Un utilisateur demande  lire ses messages
###
proc MDS::pub_check_messages {nick host hand chan arg} {
	if { (![channel get $chan MDS]) || (($MDS::antiflood == 1) && ([MDS::antiflood [MDS::clean_data $chan] $hand "read"])) } { return }
	# on vrifie que l'utilisateur a potentiellement des messages non-lus afin de ne pas aller plus loin inutilement
	if { ([lsearch -exact -nocase -index 0 $MDS::recipientlist $hand] == -1) && ([lsearch -exact -nocase -index 0 $MDS::recipientlist $nick] == -1) } { return }
	MDS::check_identity $nick $host $hand $chan "pub" "receive" $arg
}
proc MDS::priv_check_messages {nick host hand arg} {
	if { (($MDS::antiflood == 1) && ([MDS::antiflood [MDS::clean_data $nick] $hand "read"])) } { return }
	if { ![onchan $nick] } {
		puthelp "$MDS::delivery_mode $nick :\003[set MDS::num_sec_color]Vous devez vous trouver sur un chan o $::botnick est prsent pour utiliser la messagerie.\003"
		return
	}
	# on vrifie que l'utilisateur a potentiellement des messages non-lus afin de ne pas aller plus loin inutilement
	if { ([lsearch -exact -nocase -index 0 $MDS::recipientlist $hand] == -1) && ([lsearch -exact -nocase -index 0 $MDS::recipientlist $nick] == -1) } { return }
	MDS::check_identity $nick $host $hand $nick "priv" "receive" $arg
}

###
### Un utilisateur veut envoyer un message
###
proc MDS::pub_sendmsg {nick host hand chan arg} {
	if { (![channel get $chan MDS]) || (($MDS::antiflood == 1) && ([MDS::antiflood [MDS::clean_data $chan] $hand "msg"])) } { return }
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 pub_sendmsg : $nick \00307|\003 $host \00307|\003 $hand \00307|\003 $chan \00307|\003 $arg" }
	MDS::check_identity $nick $host $hand $chan "pub" "send" $arg
}
proc MDS::priv_sendmsg {nick host hand arg} {
	if { (($MDS::antiflood == 1) && ([MDS::antiflood [MDS::clean_data $nick] $hand "msg"])) } { return }
	if { ![onchan $nick] } {
		puthelp "$MDS::delivery_mode $nick :\003[set MDS::num_sec_color]Vous devez vous trouver sur un chan o $::botnick est prsent pour utiliser la messagerie.\003"
		return
	}
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 priv_sendmsg : $nick \00307|\003 $host \00307|\003 $hand \00307|\003 $arg" }
	MDS::check_identity $nick $host $hand $nick "priv" "send" $arg
}

###
### Vrification d'identit
###
proc MDS::check_identity {nick host hand chan is_public mode arg} {
	# $mode peut valoir "receive" ou "send" selon qu'il s'agit d'une vrification d'identit lors de
	# l'envoi d'un message ou de sa rception.
	# $is_public peut valoir "pub" ou "priv" selon que la demande a t effectue en public ou en priv.
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 check_identity : $nick \00307|\003 $host \00307|\003 $hand \00307|\003 $chan \00307|\003 $is_public \00307|\003 $mode \00307|\003 $arg" }
	if { $mode eq "receive" } {
		# l'utilisateur a demand  recevoir ses messages, on supprime les infos concernant
		# ses rappels de messages non lus
		if { [set unreadmsgtimer [lsearch -inline -index 1 [timers] "*MDS::unreadmsgtimertable([set clean_nick [MDS::clean_data $nick]])*"]] ne "" } {
			killtimer [lindex $unreadmsgtimer 2]
			if { [info exists MDS::unreadmsgtimertable($clean_nick)] } { unset MDS::unreadmsgtimertable($clean_nick) }
		}
	}
	# Si un service NickServ est disponible, on l'interroge
	if { $MDS::nickserv ne "" } {
		# on lance un timer qui limite la dure de vie de l'entre qu'on va crer dans statusquerytimertable
		#	Je contourne un bug que je ne comprends pas pour l'instant, en testant si l'array existe avant d'y toucher;
		# arriv  ce point, l'array devrait pourtant forcment exister mais a ne semble pas toujours tre le cas.
#		set statusquerytimerID [utimer $MDS::serviceslag [list unset ::MDS::statusquerytimertable([lindex [array get ::MDS::statusquerytimertable] 0])]]
		set statusquerytimerID [utimer $MDS::serviceslag [list if { [array exists ::MDS::statusquerytimertable] } { unset ::MDS::statusquerytimertable([lindex [array get ::MDS::statusquerytimertable] 0]) }]]

		# on cre une entre dans la table de timers de whois afin d'avoir  disposition les informations utiles lors de la rception de la rponse au NS STATUS
		variable statusquerytimertable
		set statusquerytimertable($statusquerytimerID) "$nick $host $hand $chan $is_public $mode $arg"
		# on lance un autre timer qui servira  grer le cas o les services n'ont pas rpondu dans le temps imparti
		variable stopwaitsrvtimertable
		set stopwaitsrvtimertable($statusquerytimerID) [utimer [expr $MDS::serviceslag + 2] [list ::MDS::stop_waiting_for_services $nick $chan]]
		# on essaie de savoir si $nick est enregistr/identifi
		putserv "PRIVMSG $MDS::nickserv :STATUS $nick"
		return
	# sinon on passe directement aux vrifications internes d'identit
	# (le paramtre "1000" force un code de retour signifiant que NickServ est indisponible)
	} else {
		MDS::internal_identity_check $nick $host $hand $chan $is_public $mode 1000 $arg
		return
	}
}

###
### Gestion de la rponse  la requte MSG $MDS::nickserv STATUS
###
proc MDS::ns_status {nick host hand text dest} {
	# codes de retour possibles du NS STATUS (commande serveur) :
	# 0 - cet utilisateur n'est pas online ou le pseudo n'est pas enregistr
	# 1 - utilisateur non reconnu comme propritaire (nick enregistr mais pas identifi)
	# 2 - utilisateur reconnu comme propritaire uniquement via la liste d'accs
	# 3 - utilisateur reconnu comme propritaire via l'identification
	# codes de retour possibles de MDS::ns_status :
	# 0001 - enregistr et identifi
	# 0010 - pas enregistr
	# 0100 - enregistr mais pas identifi

	# si l'auteur de la notice n'est pas $nickserv ou si la notice ne commence pas
	# par STATUS ou si aucun test d'identit n'est en cours, il ne s'agit pas
	# d'une requte de MDS et on passe.
	set array_content [array get MDS::statusquerytimertable]
	if { ([string tolower $nick] ne [string tolower $MDS::nickserv]) || (![string match -nocase "STATUS *" $text]) || ($array_content eq "") } {
	 	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 ns_info_reg : MDS::statusquerytimertable est vide, $MDS::scriptname n'est donc pas en attente d'une rponse de $MDS::nickserv \037OU\037 la notice n'mane pas de $MDS::nickserv OU la notice n'est pas une rponse  une demande de STATUS." }
		return
	# si l'identit stocke dans MDS::statusquerytimertable ne correspond pas avec le
	# nick renvoy par la notice, on signale un dysfonctionnement
	} elseif { [string tolower [set identity [lindex [split [set array_entry [lindex $array_content 1]]] 0]]] ne [string tolower [lindex [split $text] 1]] } {
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 Dysfonctionnement dtect : la notice reue de $MDS::nickserv ($text) ne correspond pas  l'attente du script (attendu : $identity)"
		return
	# sinon on traite la notice
	} else {
		if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 ns_status : $nick \00307|\003 $host \00307|\003 $hand \00307|\003 $text \00307|\003 $dest" }
		# on arrte le timer d'expiration de la requte
		if { [lsearch -exact -index 2 [utimers] [set statusquerytimerID [lindex [array get ::MDS::statusquerytimertable] 0]]] != -1 } {
			killutimer $statusquerytimerID
		}
		unset MDS::statusquerytimertable($statusquerytimerID)
		# on arrte la fonction de timeout des services
		if { ([lsearch -exact -index 2 [utimers] $MDS::stopwaitsrvtimertable($statusquerytimerID)] != -1) } {
			killutimer $MDS::stopwaitsrvtimertable($statusquerytimerID)
		}
		unset MDS::stopwaitsrvtimertable($statusquerytimerID)
		set status [lindex [split $text] 2]
		lassign [split $array_entry] entry_nick entry_host entry_hand entry_chan entry_is_public entry_mode
		set entry_arg [join [lrange [split $array_entry] 6 end]]
		if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 rcupration de variables par ns_status : $entry_nick \00307|\003 $entry_host \00307|\003 $entry_hand \00307|\003 $entry_chan \00307|\003 $entry_is_public \00307|\003 $entry_mode \00307|\003 $entry_arg" }
		# cas o $identity n'est pas enregistr
		if { $status == 0 } {
			MDS::internal_identity_check $entry_nick $entry_host $entry_hand $entry_chan $entry_is_public $entry_mode 0010 $entry_arg
			return
		# cas o $identity est enregistr mais pas identifi
		} elseif { ($status == 1) || ($status == 2) } {
			MDS::internal_identity_check $entry_nick $entry_host $entry_hand $entry_chan $entry_is_public $entry_mode 0100 $entry_arg
			return
		# cas o $identity est enregistr et identifi
	  } else {
			MDS::internal_identity_check $entry_nick $entry_host $entry_hand $entry_chan $entry_is_public $entry_mode 0001 $entry_arg
			return
		}
	}
}

###
### Gestion du cas o les services n'ont pas rpondu aux requtes dans le temps imparti
###
proc MDS::stop_waiting_for_services {nick chan} {
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 stop_waiting_for_services : $nick \00307|\003 $chan" }
	puthelp "PRIVMSG [join $chan] :[code 04]\[$MDS::scriptname - WARNING\][code endcolor] Un dysfonctionnement a t dtect. Un peu de lag peut en tre la cause, vous pouvez ventuellement ressayer d'ici quelques instants. Si celui-ci persiste, veuillez en informer un administrateur."
	putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 La vrification d'identit pour\00307 $nick\003 a chou : les services n'ont pas rpondu dans le temps imparti. Peut-tre le serveur subit-il une maintenance ou un dysfonctionnement."
	putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 Veuillez toutefois vrifier que\00307 $MDS::nickserv\003 est bien le nom du service de nick sur votre serveur et que\00307 $MDS::serviceslag secondes\003 est un dlai suffisant pour tenir compte du lag potentiel."
}

###
### Vrifications internes d'identit
###
proc MDS::internal_identity_check {nick host hand chan is_public mode pre_return_code arg} {
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 internal_identity_check : $nick \00307|\003 $host \00307|\003 $hand \00307|\003 $chan \00307|\003 $mode \00307|\003 $pre_return_code \00307|\003 $arg" }
	# identification du destinataire
	if { $mode eq "receive" } {
		# l'utilisateur a demand  recevoir ses messages, on supprime les infos concernant
		# ses rappels de messages non lus
		if { [set unreadmsgtimer [lsearch -inline -index 1 [timers] "*MDS::unreadmsgtimertable([set clean_nick [MDS::clean_data $nick]])*"]] ne "" } {
			killtimer [lindex $unreadmsgtimer 2]
			if { [info exists MDS::unreadmsgtimertable($clean_nick)] } { unset MDS::unreadmsgtimertable($clean_nick) }
		}
		if { $hand ne "*" } {
			if { [lsearch -exact -nocase $MDS::handle_exempt_list $hand] == -1 } {
				if { ([validuser $nick]) && ([string tolower $hand] ne [string tolower $nick]) } {
					if { [lsearch -exact -nocase -index 0 $MDS::recipientlist $hand] != -1 } {
						# $nick a un handle qui n'est pas un handle gnrique ET $nick est aussi un autre handle valide ET $hand a un message
						set return_code 00000001
					} elseif { [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick] != -1 } {
						# $nick a un handle qui n'est pas un handle gnrique ET $nick est aussi un autre handle valide ET $nick a un message
						set return_code 00000010
					} else { return }
				} else {
					if { [lsearch -exact -nocase -index 0 $MDS::recipientlist $hand] != -1 } {
						# $nick a un handle qui n'est pas un handle gnrique ET $nick n'est pas un autre handle valide ET $hand a un message
						set return_code 00000100
					} elseif { [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick] != -1 } {
						# $nick a un handle qui n'est pas un handle gnrique ET $nick n'est pas un autre handle valide ET $nick a un message
						set return_code 00001000
					} else { return }
				}
			} else {
				if { ([validuser $nick]) && ([string tolower $hand] ne [string tolower $nick]) } {
					if { [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick] != -1 } {
						# $nick a un handle gnrique ET $nick est aussi un autre handle valide ET $nick a un message
						set return_code 00010000
					} else { return }
				} else {
					if { [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick] != -1 } {
						# $nick a un handle gnrique ET $nick n'est pas aussi un autre handle valide ET $nick a un message
						set return_code 00100000
					} else { return }	
				}
			}
		} else {
			if { [validuser $nick] } {
				if { [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick] != -1 } {
					# $nick n'a pas de handle ET $nick est aussi un handle valide ET $nick a un message
					set return_code 01000000
				} else { return }
			} else {
				if { [lsearch -exact -nocase -index 0 $MDS::recipientlist $nick] != -1 } {
					# $nick n'a pas de handle ET $nick n'est pas un handle valide ET $nick a un message
					set return_code 10000000
				} else { return }
			}
		}
		MDS::deliver_or_deny $nick $host $hand $chan $is_public $pre_return_code$return_code
	# identification de l'expditeur
	} elseif { $mode eq "send" } {
		if { $hand ne "*" } {
			if { [lsearch -exact -nocase $MDS::handle_exempt_list $hand] == -1 } {
				if { ([validuser $nick]) && ([string tolower $hand] ne [string tolower $nick]) } {
					# $nick a un handle qui n'est pas un handle gnrique ET $nick est aussi un autre handle valide
					set return_code 000001
				} else {
					# $nick a un handle qui n'est pas un handle gnrique ET $nick n'est pas un autre handle valide
					set return_code 000010
				}
			} else {
				if { ([validuser $nick]) && ([string tolower $hand] ne [string tolower $nick]) } {
					# $nick a un handle gnrique ET $nick est aussi un autre handle valide
					set return_code 000100
				} else {
					# $nick a un handle gnrique ET $nick n'est pas aussi un autre handle valide
					set return_code 001000
				}
			}
		} else {
			if { [validuser $nick] } {
				# $nick n'a pas de handle ET $nick est aussi un handle valide
				set return_code 010000
			} else {
				# $nick n'a pas de handle ET $nick n'est pas un handle valide
				set return_code 100000
			}
		}
		MDS::sendmsg $nick $host $hand $chan $is_public $pre_return_code$return_code user - $arg
	}
	return
}

###
### Envoi d'un message
###
proc MDS::sendmsg {nick host hand chan is_public return_code is_system external_script_name arg} {
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 sendmsg : $nick \00307|\003 $host \00307|\003 $hand \00307|\003 $chan \00307|\003 $is_public \00307|\003 $return_code \00307|\003 $external_script_name \00307|\003 $arg" }
	if { $is_public eq "pub" } { set puthelp_pattern "PRIVMSG $chan :" } { set puthelp_pattern "$MDS::delivery_mode $nick :" }
	if { ([llength [set arg [split $arg]]] < 2) && ($is_system eq "user") } {
		if { ($MDS::multi_recipient == 1) && ($MDS::max_recipients > 1) } {
			puthelp "$puthelp_pattern[code underline]Syntaxe[code underline] : [code bold]$MDS::pub_msg_cmd[code bold] [code 14]<[code endcolor]destinataire[code 14]>\[[code endcolor],destinataire,[code 14]...\] <[code endcolor]message[code 14]>[code endcolor] [code 07]|[code endcolor] Envoie un message  quelqu'un. Le message lui sera dlivr ds qu'il manifestera sa prsence sur un chan o se trouve $::botnick, c'est  dire ds qu'on sera certain d'avoir toute son attention."
		} else {
			puthelp "$puthelp_pattern[code underline]Syntaxe[code underline] : [code bold]$MDS::pub_msg_cmd[code bold] [code 14]<[code endcolor]destinataire[code 14]> <[code endcolor]message[code 14]>[code endcolor] [code 07]|[code endcolor] Envoie un message  quelqu'un. Le message lui sera dlivr ds qu'il manifestera sa prsence sur un chan o se trouve $::botnick, c'est  dire ds qu'on sera certain d'avoir toute son attention."
		}
		MDS::antiflood_close_instance [MDS::clean_data $chan] "msg"
		return
	} elseif { ((([set num_targets [llength [set targets [split [join [lindex [split $arg] 0]] ","]]]] > 1) && ($MDS::max_recipients == 1)) || ($num_targets > $MDS::max_recipients)) && ($is_system eq "user") && ((($is_public eq "pub") && (![matchattr $hand $MDS::admin_flags $chan])) || (($is_public eq "priv") && (![matchattr $hand $MDS::admin_flags]))) } {
		puthelp "$puthelp_pattern\003[set MDS::num_sec_color]Vous ne pouvez pas envoyer de message  plus [if {$MDS::max_recipients == 1} { set dummy "d'un destinataire" } { set dummy "de $MDS::max_recipients destinataires" }]  la fois."
		MDS::antiflood_close_instance [MDS::clean_data $chan] "msg"
		return
	} elseif { ![string length [join $targets ""]] } {
		puthelp "$puthelp_pattern\003[set MDS::num_sec_color]Vous devez indiquer au moins un destinataire."
		MDS::antiflood_close_instance [MDS::clean_data $chan] "msg"
		return
	} elseif { ([string length [set in_message [join [lrange $arg 1 end]]]] < $MDS::min_message_length) && ($is_system eq "user") } {
		puthelp "$puthelp_pattern\003[set MDS::num_sec_color]Votre message doit comporter au moins \003\002$MDS::min_message_length\002\003$MDS::num_sec_color caractres.\003"
		return
	} else {
		# Si le message est envoy par un utilisateur
		if { $is_system eq "user" } {
			# si l'expditeur possde un handle et qu'il n'est pas gnrique, on l'appelle par son handle, sinon par son nick
			if { ($hand ne "*") && ([lsearch -exact -nocase $MDS::handle_exempt_list $hand] == -1) } { set sender $hand } else { set sender $nick }
			# Au cas o l'identit de l'expditeur du message prsente une anomalie, on affiche l'information en PL et on log.
			set NickServ_status [string range $return_code 0 3]
			if { $NickServ_status == 0001 } {
				set NickServ_status ", enregistr et identifi sur $MDS::nickserv,"
			} elseif { $NickServ_status == 0010 } {
				set NickServ_status ", pas enregistr sur $MDS::nickserv,"
			} elseif { $NickServ_status == 0100 } {
				set NickServ_status ", enregistr sur $MDS::nickserv mais pas identifi,"
			} else {
				set NickServ_status ""
			}
			set trust_level [switch -- $return_code {
				0001000010 {set dummy "\00303excellent\003"}
				0001001000 - 0001100000 - 0010000010 - 1000000010 {set dummy "\00303bon\003"}
				0001010000 - 0010001000 - 0010100000 - 0100000010 - 0100100000 - 1000001000 - 1000100000 {set dummy "\00307passable\003"}
				0001000100 - 0010000100 - 0010010000 - 0100001000 - 0100010000 - 1000000100 {set dummy "\00304mauvais\003"}
				0001000001 - 0010000001 - 0100000001 - 0100000100 - 1000000001 - 1000010000 {set dummy "\00304trs mauvais\003"}
			}]
			# si le code de retour de la proc d'identification figure parmi ceux-ci, alors l'identit de l'expditeur prsente une anomalie
			if { [lsearch [list 0001000001 0001000100 0001010000 0010000001 0010000100 0010010000 0100000001 0100000010 0100000100 0100001000 0100010000 0100100000 1000000001 1000000100 1000010000] $return_code] != -1 } {
				putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick\003[if {$is_public eq "pub"} {set dummy " @ \00307$chan\003"}] vient d'envoyer un message mais son identit prsente une anomalie, il est possible qu'il ne soit pas celui qu'il prtend tre : \00307$nick!$host\003[set NickServ_status] reconnu comme \00307$hand\003. Niveau de confiance : $trust_level."
			}
			# On accole le code de retour de l'identification de l'expditeur  son nick
			set return_code_sender $return_code*$sender
			# on empche l'envoi d'un message trop long pour s'afficher intgralement chez le destinataire
			if { [string length [concat [set pattern "$MDS::color_marker[set MDS::key_color]\[000000000\][set MDS::def_color] \002$sender\002 a laiss ce message pour vous [if { $is_public eq "pub" } { set dummy "sur $chan " } { set dummy "" }]le 00/00/00  00h00 : \003 "] $in_message]]  > $MDS::max_line_length  } {
				puthelp "$puthelp_pattern\003[set MDS::num_sec_color]Afin d'tre dlivr intgralement au destinataire, votre message ne doit pas dpasser \002[set max_length [expr $MDS::max_line_length - [string length $pattern]]]\002 caractres; il en comporte \002[set msg_length [string length $in_message]]\002, soit \002[expr $msg_length - $max_length]\002 en trop. Veuillez le raccourcir ou bien le diviser en plusieurs parties.\003"
				return
			}
		# Si le message est envoy par un autre script
		} else {
			set sender $::botnick
			set return_code_sender 0001000010*$sender
		}
		set msg_to_eggdrop 0
		set real_targets ""
		set max_msg_reached_for ""
		# on identifie le(s) destinataire(s)
		foreach target $targets {
			if { $target ne "" } {
				set targethand [nick2hand $target]
				if { ((($is_public eq "pub") && ([onchan $target $chan])) || (($is_public eq "priv") && ([onchan $target]))) && ($targethand ne "*") && ([lsearch -exact -nocase $MDS::handle_exempt_list $targethand] == -1) } {
					set recipient $targethand
					set idbyhand 1
				} else {
					set recipient $target
					set idbyhand 0
				}
				# on vite que le message soit envoy plus d'une fois  la mme personne.
				if { [lsearch -nocase $real_targets $recipient] == -1 } {
					lassign [lindex $MDS::recipientlist [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $recipient]]] dummy num_M num_C num_A
					# on empche l'envoi de messages  l'eggdrop
					if { ($target eq $::nick) || ($target eq [nick2hand $::nick]) } {
						if { !$msg_to_eggdrop } {
							puthelp "$MDS::delivery_mode $nick :Le message pour $::nick a t ignor."
							set msg_to_eggdrop 1
						}
						continue
					# si le destinataire a atteint le nombre maximum de messages en
					# attente qu'il peut avoir, on en informe l'expditeur et on n'envoie
					# pas le message.
					} elseif { ($num_M >= $MDS::max_messages_per_recipient) && ((($is_public eq "pub") && (![matchattr $hand $MDS::admin_flags $chan])) || (($is_public eq "priv") && (![matchattr $hand $MDS::admin_flags]))) } {
						if { [lsearch -nocase $max_msg_reached_for $recipient] == -1 } {
							puthelp "$MDS::delivery_mode $nick :Le nombre maximum de messages en attente pour $recipient a t atteint ($num_M message[MDS::plural1 $num_M]). Votre message ne lui a pas t envoy."
							lappend max_msg_reached_for $recipient
						}
						continue
					} else {
						lappend real_targets $recipient
						# on utilise un string trimleft pour supprimer les 0 du dbut du compteur,
						# sinon Tcl croit que c'est une valeur octale
						set MDS::current_msg_id [expr [string trimleft $MDS::current_msg_id 0] + 1]
						set message "M*$MDS::current_msg_id $return_code_sender $hand*$nick*$host $recipient [if {$is_public eq "pub"} {set dummy $chan} {set dummy priv}] [strftime "%d/%m/%Y"] [strftime "%Hh%M"] [unixtime] - - [string map {" " [[_SPACE_]]} $external_script_name] $in_message"
						set fileId_msgdb [open $MDS::msgdb_file a+]
						# on force l'encodage car sinon ce message d'exemple ne fonctionne pas correctement : "test n1 "
						puts $fileId_msgdb [encoding convertto identity $message]
						seek $fileId_msgdb 0 start
						puts $fileId_msgdb "\[[format %09g $MDS::current_msg_id]\]"
						close $fileId_msgdb
						# on incrmente le compteur de messages non-lus du destinataire
						if {$recipientlist_index == -1} {
							lappend MDS::recipientlist [list $recipient 1 0 0]
						} else {
							set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index [list $recipient [expr $num_M + 1] $num_C $num_A]]
						}
						if { $MDS::DEBUGMODE } { putlog "sendmsg (+M) : $recipient ($num_M $num_C $num_A) + (1 0 0) = ([expr $num_M + 1] $num_C $num_A)" }
						MDS::reset_unread_msg_status $recipient
						if { $idbyhand } { MDS::reset_unread_msg_status $target }
					}
				}
			}
		}
		if { ($is_system eq "user") && ($max_msg_reached_for eq "") } { 
			puthelp "$MDS::delivery_mode $nick :Message pour [string map [list " " "\003$MDS::num_sec_color / \003"] [join $real_targets]] accept"
			putloglev o * "\00314\[$MDS::scriptname\] [set num_targets [llength $real_targets]] nouveau[MDS::plural2 $num_targets] message[MDS::plural1 $num_targets] enregistr[MDS::plural1 $num_targets]\003"
		}
		return
	}
}

###
### Dlivrance des messages ou signalement d'une anomalie dans l'identit du
### destinataire selon le code d'erreur retourn
###
proc MDS::deliver_or_deny {nick host hand chan is_public return_code} {
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 deliver_or_deny : $nick \00307|\003 $host \00307|\003 $hand \00307|\003 $chan \00307|\003 $is_public \00307|\003 $return_code" }
	# enregistr + identifi / handle / pas handle gnrique / nick != autre handle valide / nick a un message -> le message est dlivr
	# enregistr + identifi / handle / handle gnrique / nick != autre handle valide / nick a un message -> le message est dlivr
	# enregistr + identifi / pas de handle / nick != autre handle valide / nick a un message -> le message est dlivr
	# pas enregistr / handle / pas handle gnrique / nick != autre handle valide / nick a un message -> le message est dlivr
	# pas enregistr / handle / handle gnrique / nick != autre handle valide / nick a un message -> le message est dlivr
	# pas enregistr / pas de handle / nick != autre handle valide / nick a un message -> le message est dlivr
	# NickServ non disponible / handle / pas handle gnrique / nick != autre handle valide / nick a un message -> le message est dlivr
	# NickServ non disponible / handle / handle gnrique / nick != autre handle valide / nick a un message -> le message est dlivr
	# NickServ non disponible / pas de handle / nick != autre handle valide / nick a un message -> le message est dlivr
	if { [lsearch [list 000100001000 000100100000 000110000000 001000001000 001000100000 001010000000 100000001000 100000100000 100010000000] $return_code] != -1 } {
		MDS::msg_delivery $nick $nick $is_public
		return
	# enregistr + identifi / handle / pas handle gnrique / nick != autre handle valide / hand a un message -> le message est dlivr
	# pas enregistr / handle / pas handle gnrique / nick != autre handle valide / hand a un message -> le message est dlivr
	# NickServ non disponible / handle / pas handle gnrique / nick != autre handle valide / hand a un message -> le message est dlivr
	} elseif { [lsearch [list 000100000100 001000000100 100000000100] $return_code] != -1 } {
		MDS::msg_delivery $nick $hand $is_public
		return
	# enregistr + identifi / handle / pas handle gnrique / nick = autre handle valide / hand a un message -> anomalie : incohrence mineure | le message est dlivr et on log l'incohrence
	} elseif { $return_code == 000100000001 } {
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand) [if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr et identifi sur $MDS::nickserv, vient de relever les messages destins  \00307$hand\003. Il peut tre intressant de noter que $nick est galement un autre handle valide ne lui appartenant pas."
		MDS::msg_delivery $nick $hand $is_public
		return
	# enregistr + identifi / handle / pas handle gnrique / nick = autre handle valide / nick a un message -> anomalie : incohrence grave | le message ne peut tre dlivr
	} elseif { $return_code == 000100000010 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit prsente une incohrence. Si vous pensez que ce message ne devrait pas s'afficher, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr et identifi sur $MDS::nickserv, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un autre handle valide ne lui appartenant pas. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# enregistr + identifi / handle / handle gnrique / nick = autre handle valide / nick a un message -> anomalie : probablement de  un host non reconnu (host pas associ au handle) | le message ne peut tre dlivr
	} elseif { $return_code == 000100010000 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit n'a pas pu tre confirme car votre ident@host n'a pas t reconnu :$MDS::flash_color $host[set MDS::def_color]. Si vous pensez que le bot aurait d vous reconnatre, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr et identifi sur $MDS::nickserv, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un autre handle valide ne lui appartenant pas. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# enregistr + identifi / pas de handle / nick = autre handle valide / nick a un message -> anomalie : probablement de  un host non reconnu (host pas associ au handle) | le message ne peut tre dlivr
	} elseif { $return_code == 000101000000 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit n'a pas pu tre confirme car votre ident@host n'a pas t reconnu :$MDS::flash_color $host[set MDS::def_color]. Si vous pensez que le bot aurait d vous reconnatre, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr et identifi sur $MDS::nickserv, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un handle valide. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# pas enregistr / handle / pas handle gnrique / nick = autre handle valide / hand a un message -> anomalie : incohrence mineure | le message est dlivr et on log l'incohrence
	} elseif { $return_code == 001000000001 } {
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, pas enregistr sur $MDS::nickserv, vient de relever les messages destins  \00307$hand\003. Il peut tre intressant de noter que $nick est galement un autre handle valide ne lui appartenant pas."
		MDS::msg_delivery $nick $hand $is_public
		return
	# pas enregistr / handle / pas handle gnrique / nick = autre handle valide / nick a un message -> anomalie : incohrence grave | le message ne peut tre dlivr
	} elseif { $return_code == 001000000010 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit prsente une incohrence. Si vous pensez que ce message ne devrait pas s'afficher, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, pas enregistr sur $MDS::nickserv, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un autre handle valide ne lui appartenant pas. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# pas enregistr / handle / handle gnrique / nick = autre handle valide / nick a un message -> anomalie : probablement de  un host non reconnu (host pas associ au handle) | le message ne peut tre dlivr
	} elseif { $return_code == 001000010000 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit n'a pas pu tre confirme car votre ident@host n'a pas t reconnu :$MDS::flash_color $host[set MDS::def_color]. Si vous pensez que le bot aurait d vous reconnatre, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, pas enregistr sur $MDS::nickserv, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un autre handle valide ne lui appartenant pas. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# pas enregistr / pas de handle / nick = autre handle valide / nick a un message -> anomalie : probablement de  un host non reconnu (host pas associ au handle) | le message ne peut tre dlivr
	} elseif { $return_code == 001001000000 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit n'a pas pu tre confirme car votre ident@host n'a pas t reconnu :$MDS::flash_color $host[set MDS::def_color]. Si vous pensez que le bot aurait d vous reconnatre, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, pas enregistr sur $MDS::nickserv, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un handle valide. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# enregistr + pas identifi / handle / pas handle gnrique / nick = autre handle valide / hand a un message -> anomalie : incohrence mineure | on signale  l'utilisateur qu'il doit s'identifier et on log l'incohrence
	} elseif { $return_code == 010000000001 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Vous avez un message non lu mais vous devez vous identifier pour pouvoir le lire. Tapez \002/msg $MDS::nickserv identify \002$MDS::sec_color<$MDS::def_color\002mot de passe\002$MDS::sec_color>$MDS::def_color. Une fois identifi, tapez [if { $is_public eq "pub" } { set dummy "\002$MDS::pub_checkmsg_cmd\002" } { set dummy "\002/msg $::botnick $MDS::priv_checkmsg_cmd\002" }]  nouveau.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr sur $MDS::nickserv mais pas identifi, essaie de relever les messages destins  \00307$hand\003. Il peut tre intressant de noter que $nick est galement un autre handle valide ne lui appartenant pas. Il a t demand  l'utilisateur de s'identifier afin de pouvoir lire ses messages."
		return
	# enregistr + pas identifi / handle / pas handle gnrique / nick = autre handle valide / nick a un message -> anomalie : incohrence grave | le message ne peut tre dlivr
	} elseif { $return_code == 010000000010 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit prsente une incohrence. Si vous pensez que ce message ne devrait pas s'afficher, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr sur $MDS::nickserv mais pas identifi, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un autre handle valide ne lui appartenant pas. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# enregistr + pas identifi / handle / pas handle gnrique / nick != autre handle valide / hand a un message -> on signale  l'utilisateur qu'il doit s'identifier
	# enregistr + pas identifi / handle / pas handle gnrique / nick != autre handle valide / nick a un message -> on signale  l'utilisateur qu'il doit s'identifier
	# enregistr + pas identifi / handle / handle gnrique / nick != autre handle valide / nick a un message -> on signale  l'utilisateur qu'il doit s'identifier
	# enregistr + pas identifi / pas de handle / nick != autre handle valide / nick a un message -> on signale  l'utilisateur qu'il doit s'identifier
	} elseif { ($return_code == 010000000100) || ($return_code == 010000001000) || ($return_code == 010000100000) || ($return_code == 010010000000) } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Vous avez un message non lu mais vous devez vous identifier pour pouvoir le lire. Tapez \002/msg $MDS::nickserv identify \002$MDS::sec_color<$MDS::def_color\002mot de passe\002$MDS::sec_color>$MDS::def_color. Une fois identifi, tapez [if { $is_public eq "pub" } { set dummy "\002$MDS::pub_checkmsg_cmd\002" } { set dummy "\002/msg $::botnick $MDS::priv_checkmsg_cmd\002" }]  nouveau.\003"
		putloglev o * "\00304\[$MDS::scriptname - INFO\]\003 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr sur $MDS::nickserv mais pas identifi, a tent de relever ses messages. Il lui a t demand de s'identifier afin d'y tre autoris."
		return
	# enregistr + pas identifi / handle / handle gnrique / nick = autre handle valide / nick a un message -> anomalie : probablement de  un host non reconnu (host pas associ au handle) | le message ne peut tre dlivr
	} elseif { $return_code == 010000010000 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit n'a pas pu tre confirme car votre ident@host n'a pas t reconnu :$MDS::flash_color $host[set MDS::def_color]. Si vous pensez que le bot aurait d vous reconnatre, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr sur $MDS::nickserv mais pas identifi, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un autre handle valide ne lui appartenant pas. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# enregistr + pas identifi / pas de handle / nick = autre handle valide / nick a un message -> anomalie : probablement de  un host non reconnu (host pas associ au handle) | si increased_security=1, le message ne peut tre dlivr; sinon on signale  l'utilisateur qu'il doit s'identifier et on log l'incohrence
	} elseif { $return_code == 010001000000 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit n'a pas pu tre confirme car votre ident@host n'a pas t reconnu :$MDS::flash_color $host[set MDS::def_color]. Si vous pensez que le bot aurait d vous reconnatre, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003, enregistr sur $MDS::nickserv mais pas identifi, essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un handle valide. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# NickServ non disponible / handle / pas handle gnrique / nick = autre handle valide / hand a un message -> anomalie : incohrence mineure | le message est dlivr et on log l'incohrence
	} elseif { $return_code == 100000000001 } {
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003 vient de relever les messages destins  \00307$hand\003. Il peut tre intressant de noter que $nick est galement un autre handle valide ne lui appartenant pas."
		MDS::msg_delivery $nick $hand $is_public
		return
	# NickServ non disponible / handle / pas handle gnrique / nick = autre handle valide / nick a un message -> anomalie : incohrence grave | le message ne peut tre dlivr
	} elseif { $return_code == 100000000010 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit prsente une incohrence. Si vous pensez que ce message ne devrait pas s'afficher, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003 essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un autre handle valide ne lui appartenant pas. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# NickServ non disponible / handle / handle gnrique / nick = autre handle valide / nick a un message -> anomalie : probablement de  un host non reconnu (host pas associ au handle) | le message ne peut tre dlivr
	} elseif { $return_code == 100000010000 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit n'a pas pu tre confirme car votre ident@host n'a pas t reconnu :$MDS::flash_color $host[set MDS::def_color]. Si vous pensez que le bot aurait d vous reconnatre, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003 essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un autre handle valide ne lui appartenant pas. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	# NickServ non disponible / pas de handle / nick = autre handle valide / nick a un message -> anomalie : probablement de  un host non reconnu (host pas associ au handle) | le message ne peut tre dlivr
	} elseif { $return_code == 100001000000 } {
		puthelp "$MDS::delivery_mode $nick :$MDS::color_marker $MDS::def_color Il y a un message pour $nick mais votre identit n'a pas pu tre confirme car votre ident@host n'a pas t reconnu :$MDS::flash_color $host[set MDS::def_color]. Si vous pensez que le bot aurait d vous reconnatre, veuillez en aviser un administrateur.\003"
		putloglev o * "\00304\[$MDS::scriptname - WARNING\]\003 \002ATTENTION\002 \00307$nick!$host ($hand)[if { $is_public eq "pub" } { set dummy " @ $chan" }]\003 essaie de relever les messages destins  \00307$nick\003 mais $nick est galement un handle valide. En raison de l'anomalie, le message n'a pas t dlivr."
		return
	}
}

###
### Dlivrance des messages
###
proc MDS::msg_delivery {actualnick identity is_public} {
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 msg_delivery : $actualnick \00307|\003 $identity \00307|\003 $is_public" }
	set lower_identity [string tolower $identity]
	set lower_actualnick [string tolower $actualnick]
	# on lit la base de donnes et on rcupre tous les messages destins  $lower_identity
	set fileId_msgdb [open $MDS::msgdb_file r]
	foreach msglineread [split [read $fileId_msgdb] "\n"] {
		if { $msglineread ne "" } {
			set msglineread [split $msglineread]
			if { ($lower_identity eq [set recipient [string tolower [lindex $msglineread 3]]]) || ($lower_actualnick eq $recipient) } {
				lappend pending_messages $msglineread
			} else {
				lappend filtered_messages $msglineread
			}
		}
	}
	close $fileId_msgdb
	set num_messages [llength $pending_messages]
	set got_normal_message 0
	foreach message $pending_messages {
		if { [set temp_place [lindex $message 4]] ne "priv" } { set place "sur $temp_place " } { set place "" }
		lassign [split [lindex $message 0] "*"] msg_type msg_id
		set recipient [lindex $message 3]
		# on isole le nom de l'expditeur et le code de retour de son identification
		lassign [split [lindex $message 1] "*"] return_code sender
		if { $sender eq "" } { set sender $return_code ; set return_code "" }
		# message normal
		if { $msg_type eq "M" } {
			set external_script_name [string map {[[_SPACE_]] " "} [lindex $message 10]]
			if { $MDS::AR_enabled } { set msg_id_pattern "$MDS::key_color\[$msg_id\]" } { set msg_id_pattern "" }
			if { $external_script_name eq "-" } {
				puthelp "$MDS::delivery_mode $actualnick :$MDS::color_marker$msg_id_pattern$MDS::def_color \002$sender\002 a laiss ce message pour vous [set place]le [lindex $message 5]  [lindex $message 6] : \003 [join [lrange $message 11 end] " "]"
			} else {
				puthelp "$MDS::delivery_mode $actualnick :$MDS::color_marker$msg_id_pattern$MDS::def_color Message de \002$external_script_name\002 laiss le [lindex $message 5]  [lindex $message 6] : \003 [join [lrange $message 11 end] " "]"
			}
			# on ajuste la liste des destinataires en attente puisqu'un message est dlivr
			lassign [lindex $MDS::recipientlist [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $recipient]]] dummy num_M num_C num_A
			if { ![set new_msg_count [MDS::decr $num_M]] && !$num_C && !$num_A } {
				set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index]
			} else {
				set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index [list $recipient $new_msg_count $num_C $num_A]]
			}
			if { $MDS::DEBUGMODE } { putlog "msg_delivery (-M) : $recipient ($num_M $num_C $num_A) + (-1 0 0) = ($new_msg_count $num_C $num_A)" }
			MDS::reset_unread_msg_status $identity
			# Au cas o l'identit de l'expditeur du message prsente une anomalie, on en avertit le destinataire.
			lassign [split [lindex $message 2] "*"] sender_hand sender_nick sender_host
			set NickServ_status [string range $return_code 0 3]
			if { $NickServ_status == 0001 } {
				set NickServ_status ", enregistr et identifi sur $MDS::nickserv,"
			} elseif { $NickServ_status == 0010 } {
				set NickServ_status ", pas enregistr sur $MDS::nickserv,"
			} elseif { $NickServ_status == 0100 } {
				set NickServ_status ", enregistr sur $MDS::nickserv mais pas identifi,"
			} else {
				set NickServ_status ""
			}
			set trust_level [switch -- $return_code {
				0001000010 {set dummy "\00303excellent\003"}
				0001001000 - 0001100000 - 0010000010 - 1000000010 {set dummy "\00303bon\003"}
				0001010000 - 0010001000 - 0010100000 - 0100000010 - 0100100000 - 1000001000 - 1000100000 {set dummy "\00307passable\003"}
				0001000100 - 0010000100 - 0010010000 - 0100001000 - 0100010000 - 1000000100 {set dummy "\00304mauvais\003"}
				0001000001 - 0010000001 - 0100000001 - 0100000100 - 1000000001 - 1000010000 {set dummy "\00304trs mauvais\003"}
			}]
			# si le code de retour de la proc d'identification figure parmi ceux-ci, alors l'identit de l'expditeur prsente une anomalie
			if { [lsearch [list 0001000001 0001000100 0001010000 0010000001 0010000100 0010010000 0100000001 0100000010 0100000100 0100001000 0100010000 0100100000 1000000001 1000000100 1000010000] $return_code] != -1 } {
				puthelp "$MDS::delivery_mode $actualnick :[set MDS::warn_color]ATTENTION$MDS::def_color l'identit de l'expditeur du message prsente une anomalie, il est possible qu'il ne soit pas celui qu'il prtend tre : $MDS::flash_color[join $sender_nick]![join $sender_host]$MDS::def_color[set NickServ_status] reconnu comme $MDS::flash_color[join $sender_hand]$MDS::def_color par $::botnick. Niveau de confiance : $trust_level."
			}
			# envoi automatique d'un accus de rception
			if { ($MDS::AD_enabled) && ($external_script_name eq "-") } {
				lappend filtered_messages "A*$msg_id [split $identity] - [split $sender] - [strftime "%d/%m/%Y"] [strftime "%Hh%M"] [unixtime] [lindex $message 5] [lindex $message 6] - [lrange $message 11 end]"
				# ajout de $sender  $recipientlist
				lassign [lindex $MDS::recipientlist [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $sender]]] dummy num_M num_C num_A
				if {$recipientlist_index == -1} {
					lappend MDS::recipientlist [list $sender 0 0 1]
				} else {
					set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index [list $sender $num_M $num_C [expr $num_A + 1]]]
				}
				if { $MDS::DEBUGMODE } { putlog "msg_delivery (+A) : $recipient ($num_M $num_C $num_A) + (0 0 1) = ($num_M $num_C [expr $num_A + 1])" }
				MDS::reset_unread_msg_status $sender
			}
			# prparation des infos en vue d'envoyer une confirmation de lecture
			if { ($MDS::AR_enabled) && ($external_script_name eq "-") } {
				incr got_normal_message
				set normal_msg_example_id $msg_id
				variable acknowledgementtable
				# structure de l'array : destinataire expditeur date_message heure_message message
				set acknowledgementtable($msg_id) [list $identity $sender [lindex $message 5] [lindex $message 6] [join [lrange $message 11 end] " "]]
				utimer $MDS::acknowledge_time [list ::MDS::unset_acknowledgementtable $msg_id]
			}
		# confirmation de lecture
		} elseif { $msg_type eq "C" } {
			puthelp "$MDS::delivery_mode $actualnick :$MDS::color_marker$MDS::key_color\[Confirmation de lecture\]$MDS::def_color Le [lindex $message 5]  [lindex $message 6], \002$sender\002 a confirm avoir lu le message que vous lui avez envoy le [lindex $message 8]  [lindex $message 9]. Rappel du message : \003 [join [lrange $message 11 end] " "]"
			# on ajuste la liste des destinataires en attente puisqu'un message vient d'tre dlivr
			lassign [lindex $MDS::recipientlist [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $recipient]]] dummy num_M num_C num_A
			set new_confirmation_count [MDS::decr $num_C]
			if { !$num_M && !$new_confirmation_count && !$num_A } {
				set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index]
			} else {
				set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index [list $recipient $num_M $new_confirmation_count $num_A]]
			}
			if { $MDS::DEBUGMODE } { putlog "msg_delivery (-C) : $recipient ($num_M $num_C $num_A) + (0 -1 0) = ($num_M $new_confirmation_count $num_A)" }
			MDS::reset_unread_msg_status $identity
		# accus de rception (passif)
		} elseif { $msg_type eq "A" } {
			puthelp "$MDS::delivery_mode $actualnick :$MDS::color_marker$MDS::key_color\[Message dlivr\]$MDS::def_color Le message que vous avez envoy  \002$sender\002 le [lindex $message 8]  [lindex $message 9] lui a t dlivr le [lindex $message 5]  [lindex $message 6]. Rappel du message : \003 [join [lrange $message 11 end] " "]"
			# on ajuste la liste des destinataires en attente puisqu'un message vient d'tre dlivr
			lassign [lindex $MDS::recipientlist [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $recipient]]] dummy num_M num_C num_A
			if { $MDS::DEBUGMODE } { putlog "identity (pas sensible  la casse) : $identity | dummy : $dummy | num_M : $num_M | num_C : $num_C | num_A : $num_A" }
			set new_receipt_count [MDS::decr $num_A]
			if { !$num_M && !$num_C && !$new_receipt_count } {
				set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index]
			} else {
				set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index [list $recipient $num_M $num_C $new_receipt_count]]
			}
			if { $MDS::DEBUGMODE } { putlog "msg_delivery (-A) : $recipient ($num_M $num_C $num_A) + (0 0 -1) = ($num_M $num_C $new_receipt_count)" }
			set ::MDS::acknowledgementtable($msg_id) [list "delivered" $identity]
			MDS::reset_unread_msg_status $identity
		} else {
			putloglev o * "\00304\[$MDS::scriptname - DEBUG\]\003 Incohrence dans la base de donnes des messages : le format du 1er champ doit tre type*id et type doit valoir M A ou C."
			putloglev o * "\00304\[$MDS::scriptname - DEBUG\]\003 Ligne dans laquelle l'erreur s'est produite : \00314[join $message " "]"
		}
	}
	putloglev o * "\00314\[$MDS::scriptname\] $num_messages message[MDS::plural1 $num_messages] dlivr[MDS::plural1 $num_messages]  $actualnick ($identity)\003"
	# on rcrit la base de donnes sans les messages qui ont t dlivrs
	set fileId_msgdb [open $MDS::msgdb_file w]
	foreach element $filtered_messages {
		puts $fileId_msgdb [join $element]
	}
	close $fileId_msgdb
	# proposition d'envoi de confirmations de lecture
	if { $MDS::AR_enabled } {
		if { $got_normal_message == 1 } {
			puthelp "$MDS::delivery_mode $actualnick :[set MDS::sec_color]Vous pouvez confirmer  l'expditeur que vous avez bien lu son message en tapant : [if { $is_public eq "pub" } { set dummy "$MDS::def_color\002$MDS::pub_read_acknowledgement_cmd $normal_msg_example_id\002$MDS::sec_color ou " } { set dummy "" }]$MDS::def_color\002/msg $::botnick $MDS::priv_read_acknowledgement_cmd $normal_msg_example_id\002$MDS::sec_color (vous avez $MDS::acknowledge_time secondes pour le faire).\003"
		} elseif { $got_normal_message > 1 } {
			if { $is_public eq "pub" } {
				puthelp "$MDS::delivery_mode $actualnick :[set MDS::sec_color]Vous pouvez confirmer aux expditeurs que vous avez bien lu leur message en tapant : $MDS::def_color\002$MDS::pub_read_acknowledgement_cmd $MDS::sec_color<[set MDS::def_color]n d'identifiant du message$MDS::sec_color> \002$MDS::flash_color|$MDS::sec_color Le n d'identifiant est affich au dbut de chaque message qui vous a t dlivr. \037exemple\037 : $MDS::def_color\002$MDS::pub_read_acknowledgement_cmd $normal_msg_example_id\002 $MDS::flash_color|$MDS::sec_color Vous avez $MDS::acknowledge_time secondes pour envoyer vos confirmations de lecture.\003"
			} else {
				puthelp "$MDS::delivery_mode $actualnick :[set MDS::sec_color]Vous pouvez confirmer aux expditeurs que vous avez bien lu leur message en tapant : $MDS::def_color\002/msg $::botnick $MDS::priv_read_acknowledgement_cmd $MDS::sec_color<[set MDS::def_color]n d'identifiant du message$MDS::sec_color> \002$MDS::flash_color|$MDS::sec_color Le n d'identifiant est affich au dbut de chaque message qui vous a t dlivr. \037exemple\037 : $MDS::def_color\002/msg $::botnick $MDS::pub_read_acknowledgement_cmd $normal_msg_example_id\002 $MDS::flash_color|$MDS::sec_color Vous avez $MDS::acknowledge_time secondes pour envoyer vos confirmations de lecture.\003"
			}
		}
	}
}

###
### envoi d'une confirmation de lecture  l'expditeur d'un message
###
proc MDS::pub_read_acknowledgement {nick host hand chan msg_id} {
	if { (![channel get $chan MDS]) || (!$MDS::AR_enabled) } { return }
	MDS::read_acknowledgement $nick $host $hand $chan $msg_id
}
proc MDS::priv_read_acknowledgement {nick host hand msg_id} {
	if { !$MDS::AR_enabled } { return }
	MDS::read_acknowledgement $nick $host $hand $nick $msg_id
}
proc MDS::read_acknowledgement {nick host hand chan msg_id} {
	if { $MDS::DEBUGMODE } { putlog "\00304\[$MDS::scriptname - DEBUG\]\003 read_acknowledgement : $nick \00307|\003 $host \00307|\003 $hand \00307|\003 $chan \00307|\003 $msg_id" }
	if { ![string first "#" $chan] } { set priv 0 } { set priv 1 }
	if { ($msg_id eq "") || (![string is digit [set msg_id [string trim $msg_id " "]]]) } {
		if { !$priv } {
			puthelp "$MDS::delivery_mode $nick :[set MDS::sec_color]La syntaxe correcte est : $MDS::def_color\002$MDS::pub_read_acknowledgement_cmd $MDS::sec_color<[set MDS::def_color]n d'identifiant du message$MDS::sec_color>\003"
		} else {
			puthelp "$MDS::delivery_mode $nick :[set MDS::sec_color]La syntaxe correcte est : $MDS::def_color\002$MDS::priv_read_acknowledgement_cmd $MDS::sec_color<[set MDS::def_color]n d'identifiant du message$MDS::sec_color>\003"
		}
		return
	} elseif { ![info exists MDS::acknowledgementtable($msg_id)] } {
		puthelp "$MDS::delivery_mode $nick :$MDS::def_color\002$msg_id\002\003$MDS::sec_color n'est pas un identifiant de message valide.\003"
		return
	} elseif {  [lindex $MDS::acknowledgementtable($msg_id) 0] eq "delivered" } {
		puthelp "$MDS::delivery_mode $nick :$MDS::def_color\002[join [lindex $MDS::acknowledgementtable($msg_id) 1]]\002 [set MDS::sec_color]a dj pris connaissance de l'accus de rception. Vous ne pouvez plus envoyer de confirmation de lecture pour le message n\003$MDS::def_color\002$msg_id\002\003$MDS::sec_color.\003"
		return
	} else {
		set lower_hand [string tolower $hand]
		set lower_nick [string tolower $nick]
		# on vrifie l'identit de celui qui envoie la confirmation de lecture
		if { ($hand ne "*") && ([lsearch -exact -nocase $MDS::handle_exempt_list $hand] == -1) } {
			set usehandle 1
			if { ([validuser $nick]) && ($lower_hand ne $lower_nick) } {
				set identity "*$hand"
			} else {
				set identity $hand
			}
		} else {
			set usehandle 0
			if { [validuser $nick] } {
				set identity "*$nick"
			} else {
				set identity $nick
			}
		}
	 	if { (($usehandle) && ([string tolower [join [lindex $MDS::acknowledgementtable($msg_id) 0]]] ne $lower_hand)) \
		 || ((!$usehandle) && ([string tolower [join [lindex $MDS::acknowledgementtable($msg_id) 0]]] ne $lower_nick)) } {
			puthelp "$MDS::delivery_mode $nick :[set MDS::sec_color]Vous n'tes pas autoris  envoyer une confirmation de lecture pour un message qui ne vous est pas destin.\003"
			return
		} else {
			# on envoie la confirmation de lecture
			set AR_message "C*$msg_id $identity $hand*$nick*$host [set recipient [join [lindex $MDS::acknowledgementtable($msg_id) 1]]] - [strftime "%d/%m/%Y"] [strftime "%Hh%M"] [unixtime] [lindex $MDS::acknowledgementtable($msg_id) 2] [lindex $MDS::acknowledgementtable($msg_id) 3] - [lrange $MDS::acknowledgementtable($msg_id) 4 end]"
			# si les accuss de rception sont activs, on rcrit la base de donnes en remplaant l'accus de rception par la confirmation de lecture
			if { $MDS::AD_enabled } {
				set fileId_msgdb [open $MDS::msgdb_file r]
				set receipt_found 0
				foreach msglineread [split [read $fileId_msgdb] "\n"] {
					if { $msglineread ne "" } {
						set msglineread [split $msglineread]
						if { [lindex $msglineread 0] ne "A*$msg_id" } {
							lappend filtered_messages $msglineread
						} else { set receipt_found 1 }
					}
				}
				close $fileId_msgdb
				lappend filtered_messages $AR_message
				set fileId_msgdb [open $MDS::msgdb_file w]
				foreach element $filtered_messages {
					puts $fileId_msgdb [join $element]
				}
				close $fileId_msgdb
				if { $receipt_found } {
					lassign [lindex $MDS::recipientlist [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $recipient]]] dummy num_M num_C num_A
					set new_receipt_count [MDS::decr $num_A]
					if { !$num_M && !$num_C && !$new_receipt_count } {
						set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index]
					} else {
						set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index [list $recipient $num_M $num_C $new_receipt_count]]
					}
					if { $MDS::DEBUGMODE } { putlog "read_acknowledgement (-A) : $recipient ($num_M $num_C $num_A) + (0 0 -1) = ($num_M $num_C $new_receipt_count)" }
				}
			} else {
				# si les accuss de rception sont dsactivs, on ajoute simplement la confirmation de lecture  la base de donnes
				set fileId_msgdb [open $MDS::msgdb_file a+]
				puts $fileId_msgdb $AR_message
				close $fileId_msgdb
			}
			# ajout de $recipient  $recipientlist
			lassign [lindex $MDS::recipientlist [set recipientlist_index [lsearch -exact -nocase -index 0 $MDS::recipientlist $recipient]]] dummy num_M num_C num_A
			if {$recipientlist_index == -1} {
				lappend MDS::recipientlist [list $recipient 0 1 0]
			} else {
				set MDS::recipientlist [lreplace $MDS::recipientlist $recipientlist_index $recipientlist_index [list $recipient $num_M [expr $num_C + 1] $num_A]]
			}
			if { $MDS::DEBUGMODE } { putlog "read_acknowledgement (+C) : $recipient ($num_M $num_C $num_A) + (0 +1 0) = ($num_M [expr $num_C + 1] $num_A)" }
			MDS::reset_unread_msg_status $recipient
			unset MDS::acknowledgementtable($msg_id)
			puthelp "$MDS::delivery_mode $nick :Confirmation de lecture envoye"
			putloglev o * "\00314\[$MDS::scriptname\] confirmation de lecture envoye\003"
		}
	}
}

###
### suppression des informations pour la confirmation de lecture aprs expiration du temps
###
proc MDS::unset_acknowledgementtable {msg_id} {
	if { [info exists MDS::acknowledgementtable($msg_id)] } {
		unset MDS::acknowledgementtable($msg_id)
	}
}

###
### Affichage de la liste des destinataires en attente
###
proc MDS::pub_destlist {nick host hand chan arg} {
	if { (![channel get $chan MDS]) || (($MDS::antiflood == 1) && ([MDS::antiflood $chan $hand "destlist"])) } {
		return
	} elseif { $MDS::recipientlist eq "" } {
		puthelp "$MDS::delivery_mode $nick :\003[set MDS::num_sec_color]Aucun message n'attend d'tre dlivr.\003"
	} else {
		puthelp "$MDS::delivery_mode $nick :$MDS::left_destlist_gimmick$MDS::def_color  Liste des personnes ayant un message en attente \003$MDS::right_destlist_gimmick"
		foreach recipient $MDS::recipientlist { lappend temp_recipientlist [lindex $recipient 0] }
		foreach {nick1 nick2 nick3 nick4 nick5 nick6} [lsort -nocase $temp_recipientlist] {
			puthelp "$MDS::delivery_mode $nick :$MDS::def_color > \003 $nick1  $nick2  $nick3  $nick4  $nick5  $nick6"
		}
		puthelp "$MDS::delivery_mode $nick :$MDS::left_destlist_gimmick$MDS::def_color  fin de la liste  \003$MDS::right_destlist_gimmick"
	}
}

###
### Backup de la base de donnes des messages
###
proc MDS::backup_db {min hour day month year} {
	putlog "\00314\[$MDS::scriptname\]\003 Backup de la base de donnes..."
  file copy -force $MDS::msgdb_file "[set MDS::msgdb_file].bak"
	# Nettoyage de la base de donnes (suppression des messages ayant expir et envoi d'un message  leur expditeur pour l'en informer)
	MDS::check_for_expired_msgs
}

###
### Suppression des messages ayant expir et envoi d'un message  leur
### expditeur pour l'en informer
###
proc MDS::check_for_expired_msgs {} {
	set fileId_msgdb [open $MDS::msgdb_file r]
	foreach msglineread [split [read $fileId_msgdb] "\n"] {
		if {$msglineread ne ""} {
			# si le message est plus ancien que $MDS::message_lifetime, on ne le garde pas et on envoie un message  son expditeur pour l'informer que son message a expir.
			if { ([string length $msglineread] != 11) && ([unixtime] >= [expr [lindex $msglineread 7] + ($MDS::message_lifetime * 86400)]) } {
				putloglev o * "\00304\[$MDS::scriptname - INFO\]\003 Un message envoy  [set recipient [join [lindex $msglineread 3]]] le [set date [lindex $msglineread 5]]  [set time [lindex $msglineread 6]] par [set sender [lindex [split [lindex $msglineread 1] *] 1]] a expir aprs $MDS::message_lifetime jours."
			} else {
				lappend msg_db $msglineread
			}
		}
	}
	close $fileId_msgdb
	set fileId_msgdb [open $MDS::msgdb_file w]
	foreach db_line $msg_db {
		puts $fileId_msgdb $db_line
	}
	close $fileId_msgdb
}

###
### Contrle du flood
###
proc MDS::antiflood {chan hand type} {
	# Si l'utilisateur est exempt du contrle de flood (option admin_flags), on arrte
	if { (((![string first "#" $chan]) && ([matchattr $hand $MDS::admin_flags $chan])) || (([string first "#" $chan] != 0) && ([matchattr $hand $MDS::admin_flags]))) } { return 0 }
	variable antiflood_msg
	if {![info exists antiflood_msg($chan$type)]} { set antiflood_msg($chan$type) 0 }
	variable instance
	if {![info exists instance($chan$type)]} { set instance($chan$type) 0 }
	set max_instances [lindex [split $MDS::floodsettings($type) ":"] 0]
	set instance_length [lindex [split $MDS::floodsettings($type) ":"] 1]
	if { $instance($chan$type) >= $max_instances } {
		if { $antiflood_msg($chan$type) == 0 } {
			set antiflood_msg($chan$type) 1
			if { $type eq "msg" } {
				if { ![string first "#" $chan] } {
					putquick "PRIVMSG $chan :[code 04]:::[code 14] Contrle de flood activ : l'envoi de messages est limit  $max_instances toutes les $instance_length secondes. Veuillez patienter.[code endcolor]"
				} else {
					putquick "$MDS::delivery_mode $chan :[code 04]:::[code 14] Contrle de flood activ : l'envoi de messages est limit  $max_instances toutes les $instance_length secondes. Veuillez patienter.[code endcolor]"
				}
			} elseif { $type eq "destlist" } {
				putquick "PRIVMSG $chan :[code 04]:::[code 14] Contrle de flood activ : l'affichage de la liste des destinataires en attente est limit  $max_instances utilisations toutes les $instance_length secondes. Veuillez patienter.[code endcolor]"
			} elseif { $type eq "read" } {
				if { ![string first "#" $chan] } {
					putquick "PRIVMSG $chan :[code 04]:::[code 14] Contrle de flood activ : l'utilisation de la commande $MDS::pub_checkmsg_cmd est limite  $max_instances fois toutes les $instance_length secondes. Veuillez patienter.[code endcolor]"
				} else {
					putquick "$MDS::delivery_mode $chan :[code 04]:::[code 14] Contrle de flood activ : l'envoi de messages est limit  $max_instances toutes les $instance_length secondes. Veuillez patienter.[code endcolor]"
				}
			}
			utimer $MDS::antiflood_msg_interval "::MDS::antiflood_msg_reset $chan $type"
		}
		return 1
	} else {
		incr instance($chan$type)
		utimer $instance_length "::MDS::antiflood_close_instance $chan $type"
		return 0
	}
}
proc MDS::antiflood_close_instance {chan type} {
	variable instance
	if { ([info exists instance($chan$type)]) && ($instance($chan$type) > 0) } { incr instance($chan$type) -1 }
}
proc MDS::antiflood_msg_reset {chan type} {
	variable antiflood_msg
	set antiflood_msg($chan$type) 0
}

###
### Accorde un mot au singulier ou au pluriel
###
proc MDS::plural1 {value} {
	if { ($value == 1) || ($value == -1) } { return "" } { return "s" }
}
proc MDS::plural2 {value} {
	if { ($value == 1) || ($value == -1) } { return "" } { return "x" }
}

###
### Dcrmente une valeur mais pas en dessous de 0
###
proc MDS::decr {value} {
	incr value -1
	if { $value > 0 } { return $value } { return 0 }
}

###
### Gestion des codes de couleur/gras/soulign dans les messages au chan
###
proc MDS::code {code} {
	if {$code == "bold"} {
		if { $MDS::codes } { return "\002" } { return "" }
	} elseif {$code == "underline"} {
		if { $MDS::codes } { return "\037" } { return "" }
	} elseif {$code == "endcolor"} {
		if { $MDS::codes } { return "\003" } { return "" }
	} else {
		if { $MDS::codes } { return "\003$code" } { return "" }
	}
}

###
### Remplacement des caractres spciaux pour utilisation dans les arrays names
###
proc MDS::clean_data {data} {
	return [string map -nocase {
		"\[" "!1!" "\]" "!2!"
		"\\" "!3!" "\|" "!4!"
		"\{" "!5!" "\}" "!6!"
		"\^" "!7!" "\$" "!8!"
	} $data]
}

###
### Restauration des caractres spciaux
###
proc MDS::restore_data {data} {
	return [string map -nocase {
		"!1!" "\[" "!2!" "\]"
		"!3!" "\\" "!4!" "\|"
		"!5!" "\{" "!6!" "\}"
		"!7!" "\^" "!8!" "\$"
	} $data]
}

###
### Binds
###
bind join $MDS::receivemsg_auth * MDS::check_if_message_on_join
bind pubm $MDS::receivemsg_auth * MDS::check_if_message
bind ctcp $MDS::receivemsg_auth ACTION MDS::action_check_if_message
bind pubm $MDS::receivemsg_auth "* %$MDS::pub_checkmsg_cmd" MDS::pub_check_messages
bind msg $MDS::receivemsg_auth $MDS::priv_checkmsg_cmd MDS::priv_check_messages
bind pub $MDS::pub_msg_auth $MDS::pub_msg_cmd MDS::pub_sendmsg
bind msg $MDS::priv_msg_auth $MDS::priv_msg_cmd MDS::priv_sendmsg
bind pub $MDS::destlist_auth $MDS::destlist_cmd MDS::pub_destlist
bind pub $MDS::pub_read_acknowledgement_auth $MDS::pub_read_acknowledgement_cmd MDS::pub_read_acknowledgement
bind msg $MDS::priv_read_acknowledgement_auth $MDS::priv_read_acknowledgement_cmd MDS::priv_read_acknowledgement
bind notc - "STATUS *" MDS::ns_status
bind part - * MDS::reset_unread_msg_status_on_quit
bind sign - * MDS::reset_unread_msg_status_on_quit
bind kick - * MDS::reset_unread_msg_status_on_kick
bind nick - * MDS::reset_unread_msg_status_on_nick
bind splt - * MDS::reset_unread_msg_status_on_splt
bind time - "[lindex $MDS::backuptime 1] [lindex $MDS::backuptime 0] * * *" MDS::backup_db
bind evnt - prerehash MDS::uninstall


putlog "\002$MDS::scriptname v$MDS::version\002 (2010 MenzAgitat) a t charg."

# ANNEXE TECHNIQUE
# ================
#
# Format de la base de donnes
# ----------------------------
# type*id code_retour_d_identification*expditeur handle*nick*host destinataire lieu date heure unixtime date_rfrence heure_rfrence nom_script_externe message
#
# type													: M = message / C = confirmation de lecture / A = accus rception
# id														: N d'identification du message (du message d'origine si type = C ou A)
# code_retour_d_identification	: code de retour de la procdure d'identification de l'expditeur
# expditeur										: Identit de l'expditeur, peut tre son nick ou son handle selon lequel
#																	des deux permet de l'identifier avec le plus de prcision. Peut tre
#																	prcd d'une * ( *expditeur ) si une anomalie a t dtecte dans
#																	l'identit de l'expditeur.
# handle												: Handle de l'expditeur
# nick													: Nick de l'expditeur
# host													: Host de l'expditeur
# destinataire									: Nick ou handle du destinataire, selon lequel des deux permet de
#																	l'identifier avec le plus de prcision.
# lieu													: Lieu depuis lequel a t envoy le message. Peut valoir "#nom_d_un_chan",
#																	"priv" (message envoy en pv) ou "-" (information inutile)
# date													: Date d'envoi du message.
# heure													: Heure d'envoi du message
# unixtime											: date et heure d'envoi du message en temps unix
# date_rfrence								: Date d'envoi du message d'origine si type = C ou A, sinon vaut "-"
# heure_rfrence								: Heure d'envoi du message d'origine si type = C ou A, sinon vaut "-"
#	nom_script_externe						: Nom du script qui a envoy le message (pour le cas o le message a t
#																	envoy par un script plutt que par un utilisateur); sinon, vaut "-"
# message												: Contenu du message envoy ou rappel du message d'origine si type = C ou A
#
#
# Codes de retour possibles de la procdure d'identification du destinataire
# --------------------------------------------------------------------------
# 000100000001	- enregistr + identifi / handle / nick = autre handle valide / hand a un message
#	000100000010	- enregistr + identifi / handle / nick = autre handle valide / nick a un message
# 000100000100	- enregistr + identifi / handle / nick != autre handle valide / hand a un message
#	000100001000	- enregistr + identifi / handle / nick != autre handle valide / nick a un message
# 000100010000	- enregistr + identifi / handle gnrique / nick = autre handle valide / nick a un message
# 000100100000	- enregistr + identifi / handle gnrique / nick != autre handle valide / nick a un message
# 000101000000	- enregistr + identifi / pas de handle / nick = handle valide / nick a un message
# 000110000000	- enregistr + identifi / pas de handle / nick != handle valide / nick a un message
# 001000000001	- pas enregistr / handle / nick = autre handle valide / hand a un message
#	001000000010	- pas enregistr / handle / nick = autre handle valide / nick a un message
# 001000000100	- pas enregistr / handle / nick != autre handle valide / hand a un message
#	001000001000	- pas enregistr / handle / nick != autre handle valide / nick a un message
# 001000010000	- pas enregistr / handle gnrique / nick = autre handle valide / nick a un message
# 001000100000	- pas enregistr / handle gnrique / nick != autre handle valide / nick a un message
# 001001000000	- pas enregistr / pas de handle / nick = handle valide / nick a un message
# 001010000000	- pas enregistr / pas de handle / nick != handle valide / nick a un message
# 010000000001	- enregistr + pas identifi / handle / nick = autre handle valide / hand a un message
#	010000000010	- enregistr + pas identifi / handle / nick = autre handle valide / nick a un message
# 010000000100	- enregistr + pas identifi / handle / nick != autre handle valide / hand a un message
#	010000001000	- enregistr + pas identifi / handle / nick != autre handle valide / nick a un message
# 010000010000	- enregistr + pas identifi / handle gnrique / nick = autre handle valide / nick a un message
# 010000100000	- enregistr + pas identifi / handle gnrique / nick != autre handle valide / nick a un message
# 010001000000	- enregistr + pas identifi / pas de handle / nick = handle valide / nick a un message
# 010010000000	- enregistr + pas identifi / pas de handle / nick != handle valide / nick a un message
# 100000000001	- NickServ non disponible / handle / nick = autre handle valide / hand a un message
#	100000000010	- NickServ non disponible / handle / nick = autre handle valide / nick a un message
# 100000000100	- NickServ non disponible / handle / nick != autre handle valide / hand a un message
#	100000001000	- NickServ non disponible / handle / nick != autre handle valide / nick a un message
# 100000010000	- NickServ non disponible / handle gnrique / nick = autre handle valide / nick a un message
# 100000100000	- NickServ non disponible / handle gnrique / nick != autre handle valide / nick a un message
# 100001000000	- NickServ non disponible / pas de handle / nick = handle valide / nick a un message
# 100010000000	- NickServ non disponible / pas de handle / nick != handle valide / nick a un message
#
# Codes de retour possibles de la procdure d'identification de l'expditeur
# --------------------------------------------------------------------------
# 0001000001	- enregistr + identifi / handle / nick = autre handle valide -> niveau de confiance : trs mauvais
# 0001000010	- enregistr + identifi / handle / nick != autre handle valide -> niveau de confiance : excellent
# 0001000100	- enregistr + identifi / handle gnrique / nick = autre handle valide -> niveau de confiance : mauvais
# 0001001000	- enregistr + identifi / handle gnrique / nick != autre handle valide -> niveau de confiance : bon
# 0001010000	- enregistr + identifi / pas de handle / nick = handle valide -> niveau de confiance : passable
# 0001100000	- enregistr + identifi / pas de handle / nick != handle valide -> niveau de confiance : bon
# 0010000001	- pas enregistr / handle / nick = autre handle valide -> niveau de confiance : trs mauvais
# 0010000010	- pas enregistr / handle / nick != autre handle valide -> niveau de confiance : bon
# 0010000100	- pas enregistr / handle gnrique / nick = autre handle valide -> niveau de confiance : mauvais
# 0010001000	- pas enregistr / handle gnrique / nick != autre handle valide -> niveau de confiance : passable
# 0010010000	- pas enregistr / pas de handle / nick = handle valide -> niveau de confiance : mauvais
# 0010100000	- pas enregistr / pas de handle / nick != handle valide -> niveau de confiance : passable
# 0100000001	- enregistr + pas identifi / handle / nick = autre handle valide -> niveau de confiance : trs mauvais
# 0100000010	- enregistr + pas identifi / handle / nick != autre handle valide -> niveau de confiance : passable
# 0100000100	- enregistr + pas identifi / handle gnrique / nick = autre handle valide -> niveau de confiance : trs mauvais
# 0100001000	- enregistr + pas identifi / handle gnrique / nick != autre handle valide -> niveau de confiance : mauvais
# 0100010000	- enregistr + pas identifi / pas de handle / nick = handle valide -> niveau de confiance : mauvais
# 0100100000	- enregistr + pas identifi / pas de handle / nick != handle valide -> niveau de confiance : passable
# 1000000001	- NickServ non disponible / handle / nick = autre handle valide -> niveau de confiance : trs mauvais
# 1000000010	- NickServ non disponible / handle / nick != autre handle valide -> niveau de confiance : bon
# 1000000100	- NickServ non disponible / handle gnrique / nick = autre handle valide -> niveau de confiance : mauvais
# 1000001000	- NickServ non disponible / handle gnrique / nick != autre handle valide -> niveau de confiance : passable
# 1000010000	- NickServ non disponible / pas de handle / nick = handle valide -> niveau de confiance : trs mauvais
# 1000100000	- NickServ non disponible / pas de handle / nick != handle valide -> niveau de confiance : passable
